{ This file was generated automatically by the Snowball to Delphi compiler. }

Unit DanishStemmer;

{$HINTS OFF}

Interface

Uses SnowballProgram;

Type
    TDanishStemmer = Class(TSnowballProgram)
    private
        I_p1 : Integer;
        S_ch : AnsiString;
    private
        a_0 : Array Of TAmong;
        a_1 : Array Of TAmong;
        a_2 : Array Of TAmong;
    public
        Constructor Create;
        Function stem : Boolean;
    private
        Function r_mark_regions : Boolean;
        Function r_main_suffix : Boolean;
        Function r_consonant_pair : Boolean;
        Function r_other_suffix : Boolean;
        Function r_undouble : Boolean;
End;

Implementation

Const
    g_v : Array [0..18] Of Char = (
        Chr(17),
        Chr(65),
        Chr(16),
        Chr(1),
        Chr(0),
        Chr(0),
        Chr(0),
        Chr(0),
        Chr(0),
        Chr(0),
        Chr(0),
        Chr(0),
        Chr(0),
        Chr(0),
        Chr(0),
        Chr(0),
        Chr(48),
        Chr(0),
        Chr(128)
    );

Const
    g_s_ending : Array [0..16] Of Char = (
        Chr(239),
        Chr(254),
        Chr(42),
        Chr(3),
        Chr(0),
        Chr(0),
        Chr(0),
        Chr(0),
        Chr(0),
        Chr(0),
        Chr(0),
        Chr(0),
        Chr(0),
        Chr(0),
        Chr(0),
        Chr(0),
        Chr(16)
    );

Constructor TDanishStemmer.Create;
Begin
    SetLength(a_0, 32);
        a_0[0].Str  := 'hed';
        a_0[0].Size := Length(a_0[0].Str);
        a_0[0].Index := -1;
        a_0[0].Result := 1;
        a_0[0].Method := nil;

        a_0[1].Str  := 'ethed';
        a_0[1].Size := Length(a_0[1].Str);
        a_0[1].Index := 0;
        a_0[1].Result := 1;
        a_0[1].Method := nil;

        a_0[2].Str  := 'ered';
        a_0[2].Size := Length(a_0[2].Str);
        a_0[2].Index := -1;
        a_0[2].Result := 1;
        a_0[2].Method := nil;

        a_0[3].Str  := 'e';
        a_0[3].Size := Length(a_0[3].Str);
        a_0[3].Index := -1;
        a_0[3].Result := 1;
        a_0[3].Method := nil;

        a_0[4].Str  := 'erede';
        a_0[4].Size := Length(a_0[4].Str);
        a_0[4].Index := 3;
        a_0[4].Result := 1;
        a_0[4].Method := nil;

        a_0[5].Str  := 'ende';
        a_0[5].Size := Length(a_0[5].Str);
        a_0[5].Index := 3;
        a_0[5].Result := 1;
        a_0[5].Method := nil;

        a_0[6].Str  := 'erende';
        a_0[6].Size := Length(a_0[6].Str);
        a_0[6].Index := 5;
        a_0[6].Result := 1;
        a_0[6].Method := nil;

        a_0[7].Str  := 'ene';
        a_0[7].Size := Length(a_0[7].Str);
        a_0[7].Index := 3;
        a_0[7].Result := 1;
        a_0[7].Method := nil;

        a_0[8].Str  := 'erne';
        a_0[8].Size := Length(a_0[8].Str);
        a_0[8].Index := 3;
        a_0[8].Result := 1;
        a_0[8].Method := nil;

        a_0[9].Str  := 'ere';
        a_0[9].Size := Length(a_0[9].Str);
        a_0[9].Index := 3;
        a_0[9].Result := 1;
        a_0[9].Method := nil;

        a_0[10].Str  := 'en';
        a_0[10].Size := Length(a_0[10].Str);
        a_0[10].Index := -1;
        a_0[10].Result := 1;
        a_0[10].Method := nil;

        a_0[11].Str  := 'heden';
        a_0[11].Size := Length(a_0[11].Str);
        a_0[11].Index := 10;
        a_0[11].Result := 1;
        a_0[11].Method := nil;

        a_0[12].Str  := 'eren';
        a_0[12].Size := Length(a_0[12].Str);
        a_0[12].Index := 10;
        a_0[12].Result := 1;
        a_0[12].Method := nil;

        a_0[13].Str  := 'er';
        a_0[13].Size := Length(a_0[13].Str);
        a_0[13].Index := -1;
        a_0[13].Result := 1;
        a_0[13].Method := nil;

        a_0[14].Str  := 'heder';
        a_0[14].Size := Length(a_0[14].Str);
        a_0[14].Index := 13;
        a_0[14].Result := 1;
        a_0[14].Method := nil;

        a_0[15].Str  := 'erer';
        a_0[15].Size := Length(a_0[15].Str);
        a_0[15].Index := 13;
        a_0[15].Result := 1;
        a_0[15].Method := nil;

        a_0[16].Str  := 's';
        a_0[16].Size := Length(a_0[16].Str);
        a_0[16].Index := -1;
        a_0[16].Result := 2;
        a_0[16].Method := nil;

        a_0[17].Str  := 'heds';
        a_0[17].Size := Length(a_0[17].Str);
        a_0[17].Index := 16;
        a_0[17].Result := 1;
        a_0[17].Method := nil;

        a_0[18].Str  := 'es';
        a_0[18].Size := Length(a_0[18].Str);
        a_0[18].Index := 16;
        a_0[18].Result := 1;
        a_0[18].Method := nil;

        a_0[19].Str  := 'endes';
        a_0[19].Size := Length(a_0[19].Str);
        a_0[19].Index := 18;
        a_0[19].Result := 1;
        a_0[19].Method := nil;

        a_0[20].Str  := 'erendes';
        a_0[20].Size := Length(a_0[20].Str);
        a_0[20].Index := 19;
        a_0[20].Result := 1;
        a_0[20].Method := nil;

        a_0[21].Str  := 'enes';
        a_0[21].Size := Length(a_0[21].Str);
        a_0[21].Index := 18;
        a_0[21].Result := 1;
        a_0[21].Method := nil;

        a_0[22].Str  := 'ernes';
        a_0[22].Size := Length(a_0[22].Str);
        a_0[22].Index := 18;
        a_0[22].Result := 1;
        a_0[22].Method := nil;

        a_0[23].Str  := 'eres';
        a_0[23].Size := Length(a_0[23].Str);
        a_0[23].Index := 18;
        a_0[23].Result := 1;
        a_0[23].Method := nil;

        a_0[24].Str  := 'ens';
        a_0[24].Size := Length(a_0[24].Str);
        a_0[24].Index := 16;
        a_0[24].Result := 1;
        a_0[24].Method := nil;

        a_0[25].Str  := 'hedens';
        a_0[25].Size := Length(a_0[25].Str);
        a_0[25].Index := 24;
        a_0[25].Result := 1;
        a_0[25].Method := nil;

        a_0[26].Str  := 'erens';
        a_0[26].Size := Length(a_0[26].Str);
        a_0[26].Index := 24;
        a_0[26].Result := 1;
        a_0[26].Method := nil;

        a_0[27].Str  := 'ers';
        a_0[27].Size := Length(a_0[27].Str);
        a_0[27].Index := 16;
        a_0[27].Result := 1;
        a_0[27].Method := nil;

        a_0[28].Str  := 'ets';
        a_0[28].Size := Length(a_0[28].Str);
        a_0[28].Index := 16;
        a_0[28].Result := 1;
        a_0[28].Method := nil;

        a_0[29].Str  := 'erets';
        a_0[29].Size := Length(a_0[29].Str);
        a_0[29].Index := 28;
        a_0[29].Result := 1;
        a_0[29].Method := nil;

        a_0[30].Str  := 'et';
        a_0[30].Size := Length(a_0[30].Str);
        a_0[30].Index := -1;
        a_0[30].Result := 1;
        a_0[30].Method := nil;

        a_0[31].Str  := 'eret';
        a_0[31].Size := Length(a_0[31].Str);
        a_0[31].Index := 30;
        a_0[31].Result := 1;
        a_0[31].Method := nil;

    SetLength(a_1, 4);
        a_1[0].Str  := 'gd';
        a_1[0].Size := Length(a_1[0].Str);
        a_1[0].Index := -1;
        a_1[0].Result := -1;
        a_1[0].Method := nil;

        a_1[1].Str  := 'dt';
        a_1[1].Size := Length(a_1[1].Str);
        a_1[1].Index := -1;
        a_1[1].Result := -1;
        a_1[1].Method := nil;

        a_1[2].Str  := 'gt';
        a_1[2].Size := Length(a_1[2].Str);
        a_1[2].Index := -1;
        a_1[2].Result := -1;
        a_1[2].Method := nil;

        a_1[3].Str  := 'kt';
        a_1[3].Size := Length(a_1[3].Str);
        a_1[3].Index := -1;
        a_1[3].Result := -1;
        a_1[3].Method := nil;

    SetLength(a_2, 5);
        a_2[0].Str  := 'ig';
        a_2[0].Size := Length(a_2[0].Str);
        a_2[0].Index := -1;
        a_2[0].Result := 1;
        a_2[0].Method := nil;

        a_2[1].Str  := 'lig';
        a_2[1].Size := Length(a_2[1].Str);
        a_2[1].Index := 0;
        a_2[1].Result := 1;
        a_2[1].Method := nil;

        a_2[2].Str  := 'elig';
        a_2[2].Size := Length(a_2[2].Str);
        a_2[2].Index := 1;
        a_2[2].Result := 1;
        a_2[2].Method := nil;

        a_2[3].Str  := 'els';
        a_2[3].Size := Length(a_2[3].Str);
        a_2[3].Index := -1;
        a_2[3].Result := 1;
        a_2[3].Method := nil;

        a_2[4].Str  := 'l'#248'st';
        a_2[4].Size := Length(a_2[4].Str);
        a_2[4].Index := -1;
        a_2[4].Result := 2;
        a_2[4].Method := nil;

End;

Function TDanishStemmer.r_mark_regions : Boolean;
Var
    C : Integer;
    v_1 : Integer;
Label
    lab0,
    lab1,
    lab2,
    lab3,
    lab4;
Begin
    { (, line 29 }
    I_p1 := FLimit;
    { goto, line 33 }
    While True Do
    Begin
        v_1 := FCursor;
        Repeat
            If (Not (InGrouping(g_v, 97, 248))) Then
            Begin
                goto lab1;
            End;
            FCursor := v_1;
            goto lab0;
        Until True;
lab1:
        FCursor := v_1;
        If (FCursor >= FLimit) Then
        Begin
            Begin Result := False; Exit; End;
        End;
        Inc(FCursor);
    End;
lab0:
    { gopast, line 33 }
    While True Do
    Begin
        Repeat
            If (Not (OutGrouping(g_v, 97, 248))) Then
            Begin
                goto lab3;
            End;
            goto lab2;
        Until True;
lab3:
        If (FCursor >= FLimit) Then
        Begin
            Begin Result := False; Exit; End;
        End;
        Inc(FCursor);
    End;
lab2:
    { setmark p1, line 33 }
    I_p1 := FCursor;
    { try, line 34 }
    Repeat
        { (, line 34 }
        If Not (I_p1 < 3) Then
        Begin
            goto lab4;
        End;
        I_p1 := 3;
    Until True;
lab4:
    Result := True;
End;

Function TDanishStemmer.r_main_suffix : Boolean;
Var
    C : Integer;
    AmongVar : Integer;
    v_1 : Integer;
    v_2 : Integer;
Begin
    { (, line 39 }
    { setlimit, line 40 }
    v_1 := FLimit - FCursor;
    { tomark, line 40 }
    If (FCursor < I_p1) Then
    Begin
        Begin Result := False; Exit; End;
    End;
    FCursor := I_p1;
    v_2 := FBkLimit;
    FBkLimit := FCursor;
    FCursor := FLimit - v_1;
    { (, line 40 }
    { [, line 40 }
    FKet := FCursor;
    { substring, line 40 }
    AmongVar := FindAmongBk(a_0, 32);
    If (AmongVar = 0) Then
    Begin
        FBkLimit := v_2;
        Begin Result := False; Exit; End;
    End;
    { ], line 40 }
    FBra := FCursor;
    FBkLimit := v_2;
    Case AmongVar Of
        0:
        Begin
            Begin Result := False; Exit; End;
        End;
        1:
        Begin
            { (, line 47 }
            { delete, line 47 }
            SliceDel;
        End;
        2:
        Begin
            { (, line 49 }
            If (Not (InGroupingBk(g_s_ending, 97, 229))) Then
            Begin
                Begin Result := False; Exit; End;
            End;
            { delete, line 49 }
            SliceDel;
        End;
    End;
    Result := True;
End;

Function TDanishStemmer.r_consonant_pair : Boolean;
Var
    C : Integer;
    v_1 : Integer;
    v_2 : Integer;
    v_3 : Integer;
Begin
    { (, line 53 }
    { test, line 54 }
    v_1 := FLimit - FCursor;
    { (, line 54 }
    { setlimit, line 55 }
    v_2 := FLimit - FCursor;
    { tomark, line 55 }
    If (FCursor < I_p1) Then
    Begin
        Begin Result := False; Exit; End;
    End;
    FCursor := I_p1;
    v_3 := FBkLimit;
    FBkLimit := FCursor;
    FCursor := FLimit - v_2;
    { (, line 55 }
    { [, line 55 }
    FKet := FCursor;
    { substring, line 55 }
    If (FindAmongBk(a_1, 4) = 0) Then
    Begin
        FBkLimit := v_3;
        Begin Result := False; Exit; End;
    End;
    { ], line 55 }
    FBra := FCursor;
    FBkLimit := v_3;
    FCursor := FLimit - v_1;
    { next, line 61 }
    If (FCursor <= FBkLimit) Then
    Begin
        Begin Result := False; Exit; End;
    End;
    Dec(FCursor);
    { ], line 61 }
    FBra := FCursor;
    { delete, line 61 }
    SliceDel;
    Result := True;
End;

Function TDanishStemmer.r_other_suffix : Boolean;
Var
    C : Integer;
    AmongVar : Integer;
    v_1 : Integer;
    v_2 : Integer;
    v_3 : Integer;
    v_4 : Integer;
Label
    lab0,
    lab1;
Begin
    { (, line 64 }
    { do, line 65 }
    v_1 := FLimit - FCursor;
    Repeat
        { (, line 65 }
        { [, line 65 }
        FKet := FCursor;
        { literal, line 65 }
        If (Not (EqSBk(2, 'st'))) Then
        Begin
            goto lab0;
        End;
        { ], line 65 }
        FBra := FCursor;
        { literal, line 65 }
        If (Not (EqSBk(2, 'ig'))) Then
        Begin
            goto lab0;
        End;
        { delete, line 65 }
        SliceDel;
    Until True;
lab0:
    FCursor := FLimit - v_1;
    { setlimit, line 66 }
    v_2 := FLimit - FCursor;
    { tomark, line 66 }
    If (FCursor < I_p1) Then
    Begin
        Begin Result := False; Exit; End;
    End;
    FCursor := I_p1;
    v_3 := FBkLimit;
    FBkLimit := FCursor;
    FCursor := FLimit - v_2;
    { (, line 66 }
    { [, line 66 }
    FKet := FCursor;
    { substring, line 66 }
    AmongVar := FindAmongBk(a_2, 5);
    If (AmongVar = 0) Then
    Begin
        FBkLimit := v_3;
        Begin Result := False; Exit; End;
    End;
    { ], line 66 }
    FBra := FCursor;
    FBkLimit := v_3;
    Case AmongVar Of
        0:
        Begin
            Begin Result := False; Exit; End;
        End;
        1:
        Begin
            { (, line 69 }
            { delete, line 69 }
            SliceDel;
            { do, line 69 }
            v_4 := FLimit - FCursor;
            Repeat
                { call consonant_pair, line 69 }
                If (Not r_consonant_pair) Then
                Begin
                    goto lab1;
                End;
            Until True;
lab1:
            FCursor := FLimit - v_4;
        End;
        2:
        Begin
            { (, line 71 }
            { <-, line 71 }
            SliceFrom('l'#248's');
        End;
    End;
    Result := True;
End;

Function TDanishStemmer.r_undouble : Boolean;
Var
    C : Integer;
    v_1 : Integer;
    v_2 : Integer;
Begin
    { (, line 74 }
    { setlimit, line 75 }
    v_1 := FLimit - FCursor;
    { tomark, line 75 }
    If (FCursor < I_p1) Then
    Begin
        Begin Result := False; Exit; End;
    End;
    FCursor := I_p1;
    v_2 := FBkLimit;
    FBkLimit := FCursor;
    FCursor := FLimit - v_1;
    { (, line 75 }
    { [, line 75 }
    FKet := FCursor;
    If (Not (OutGroupingBk(g_v, 97, 248))) Then
    Begin
        FBkLimit := v_2;
        Begin Result := False; Exit; End;
    End;
    { ], line 75 }
    FBra := FCursor;
    { -> ch, line 75 }
    S_ch := SliceTo(S_ch);
    FBkLimit := v_2;
    { name ch, line 76 }
    If (Not (EqVBk(S_ch))) Then
    Begin
        Begin Result := False; Exit; End;
    End;
    { delete, line 77 }
    SliceDel;
    Result := True;
End;

Function TDanishStemmer.stem : Boolean;
Var
    C : Integer;
    v_1 : Integer;
    v_2 : Integer;
    v_3 : Integer;
    v_4 : Integer;
    v_5 : Integer;
Label
    lab0,
    lab1,
    lab2,
    lab3,
    lab4;
Begin
    { (, line 81 }
    { do, line 83 }
    v_1 := FCursor;
    Repeat
        { call mark_regions, line 83 }
        If (Not r_mark_regions) Then
        Begin
            goto lab0;
        End;
    Until True;
lab0:
    FCursor := v_1;
    { backwards, line 84 }
    FBkLimit := FCursor; FCursor := FLimit;
    { (, line 84 }
    { do, line 85 }
    v_2 := FLimit - FCursor;
    Repeat
        { call main_suffix, line 85 }
        If (Not r_main_suffix) Then
        Begin
            goto lab1;
        End;
    Until True;
lab1:
    FCursor := FLimit - v_2;
    { do, line 86 }
    v_3 := FLimit - FCursor;
    Repeat
        { call consonant_pair, line 86 }
        If (Not r_consonant_pair) Then
        Begin
            goto lab2;
        End;
    Until True;
lab2:
    FCursor := FLimit - v_3;
    { do, line 87 }
    v_4 := FLimit - FCursor;
    Repeat
        { call other_suffix, line 87 }
        If (Not r_other_suffix) Then
        Begin
            goto lab3;
        End;
    Until True;
lab3:
    FCursor := FLimit - v_4;
    { do, line 88 }
    v_5 := FLimit - FCursor;
    Repeat
        { call undouble, line 88 }
        If (Not r_undouble) Then
        Begin
            goto lab4;
        End;
    Until True;
lab4:
    FCursor := FLimit - v_5;
    FCursor := FBkLimit;    Result := True;
End;

End.
