{ This file was generated automatically by the Snowball to Delphi compiler. }

Unit FinnishStemmer;

{$HINTS OFF}

Interface

Uses SnowballProgram;

Type
    TFinnishStemmer = Class(TSnowballProgram)
    private
        B_ending_removed : Boolean;
        S_x : AnsiString;
        I_p2 : Integer;
        I_p1 : Integer;
    private
        a_0 : Array Of TAmong;
        a_1 : Array Of TAmong;
        a_2 : Array Of TAmong;
        a_3 : Array Of TAmong;
        a_4 : Array Of TAmong;
        a_5 : Array Of TAmong;
        a_6 : Array Of TAmong;
        a_7 : Array Of TAmong;
        a_8 : Array Of TAmong;
        a_9 : Array Of TAmong;
    public
        Constructor Create;
        Function stem : Boolean;
    private
        Function r_mark_regions : Boolean;
        Function r_R2 : Boolean;
        Function r_particle_etc : Boolean;
        Function r_possessive : Boolean;
        Function r_LONG : Boolean;
        Function r_VI : Boolean;
        Function r_case : Boolean;
        Function r_other_endings : Boolean;
        Function r_i_plural : Boolean;
        Function r_t_plural : Boolean;
        Function r_tidy : Boolean;
End;

Implementation

Const
    g_AEI : Array [0..16] Of Char = (
        Chr(17),
        Chr(1),
        Chr(0),
        Chr(0),
        Chr(0),
        Chr(0),
        Chr(0),
        Chr(0),
        Chr(0),
        Chr(0),
        Chr(0),
        Chr(0),
        Chr(0),
        Chr(0),
        Chr(0),
        Chr(0),
        Chr(8)
    );

Const
    g_v : Array [0..18] Of Char = (
        Chr(17),
        Chr(65),
        Chr(16),
        Chr(1),
        Chr(0),
        Chr(0),
        Chr(0),
        Chr(0),
        Chr(0),
        Chr(0),
        Chr(0),
        Chr(0),
        Chr(0),
        Chr(0),
        Chr(0),
        Chr(0),
        Chr(8),
        Chr(0),
        Chr(32)
    );

Const
    g_V2 : Array [0..18] Of Char = (
        Chr(17),
        Chr(65),
        Chr(16),
        Chr(0),
        Chr(0),
        Chr(0),
        Chr(0),
        Chr(0),
        Chr(0),
        Chr(0),
        Chr(0),
        Chr(0),
        Chr(0),
        Chr(0),
        Chr(0),
        Chr(0),
        Chr(8),
        Chr(0),
        Chr(32)
    );

Const
    g_particle_end : Array [0..18] Of Char = (
        Chr(17),
        Chr(97),
        Chr(24),
        Chr(1),
        Chr(0),
        Chr(0),
        Chr(0),
        Chr(0),
        Chr(0),
        Chr(0),
        Chr(0),
        Chr(0),
        Chr(0),
        Chr(0),
        Chr(0),
        Chr(0),
        Chr(8),
        Chr(0),
        Chr(32)
    );

Constructor TFinnishStemmer.Create;
Begin
    SetLength(a_0, 10);
        a_0[0].Str  := 'pa';
        a_0[0].Size := Length(a_0[0].Str);
        a_0[0].Index := -1;
        a_0[0].Result := 1;
        a_0[0].Method := nil;

        a_0[1].Str  := 'sti';
        a_0[1].Size := Length(a_0[1].Str);
        a_0[1].Index := -1;
        a_0[1].Result := 2;
        a_0[1].Method := nil;

        a_0[2].Str  := 'kaan';
        a_0[2].Size := Length(a_0[2].Str);
        a_0[2].Index := -1;
        a_0[2].Result := 1;
        a_0[2].Method := nil;

        a_0[3].Str  := 'han';
        a_0[3].Size := Length(a_0[3].Str);
        a_0[3].Index := -1;
        a_0[3].Result := 1;
        a_0[3].Method := nil;

        a_0[4].Str  := 'kin';
        a_0[4].Size := Length(a_0[4].Str);
        a_0[4].Index := -1;
        a_0[4].Result := 1;
        a_0[4].Method := nil;

        a_0[5].Str  := 'h'#228'n';
        a_0[5].Size := Length(a_0[5].Str);
        a_0[5].Index := -1;
        a_0[5].Result := 1;
        a_0[5].Method := nil;

        a_0[6].Str  := 'k'#228''#228'n';
        a_0[6].Size := Length(a_0[6].Str);
        a_0[6].Index := -1;
        a_0[6].Result := 1;
        a_0[6].Method := nil;

        a_0[7].Str  := 'ko';
        a_0[7].Size := Length(a_0[7].Str);
        a_0[7].Index := -1;
        a_0[7].Result := 1;
        a_0[7].Method := nil;

        a_0[8].Str  := 'p'#228'';
        a_0[8].Size := Length(a_0[8].Str);
        a_0[8].Index := -1;
        a_0[8].Result := 1;
        a_0[8].Method := nil;

        a_0[9].Str  := 'k'#246'';
        a_0[9].Size := Length(a_0[9].Str);
        a_0[9].Index := -1;
        a_0[9].Result := 1;
        a_0[9].Method := nil;

    SetLength(a_1, 6);
        a_1[0].Str  := 'lla';
        a_1[0].Size := Length(a_1[0].Str);
        a_1[0].Index := -1;
        a_1[0].Result := -1;
        a_1[0].Method := nil;

        a_1[1].Str  := 'na';
        a_1[1].Size := Length(a_1[1].Str);
        a_1[1].Index := -1;
        a_1[1].Result := -1;
        a_1[1].Method := nil;

        a_1[2].Str  := 'ssa';
        a_1[2].Size := Length(a_1[2].Str);
        a_1[2].Index := -1;
        a_1[2].Result := -1;
        a_1[2].Method := nil;

        a_1[3].Str  := 'ta';
        a_1[3].Size := Length(a_1[3].Str);
        a_1[3].Index := -1;
        a_1[3].Result := -1;
        a_1[3].Method := nil;

        a_1[4].Str  := 'lta';
        a_1[4].Size := Length(a_1[4].Str);
        a_1[4].Index := 3;
        a_1[4].Result := -1;
        a_1[4].Method := nil;

        a_1[5].Str  := 'sta';
        a_1[5].Size := Length(a_1[5].Str);
        a_1[5].Index := 3;
        a_1[5].Result := -1;
        a_1[5].Method := nil;

    SetLength(a_2, 6);
        a_2[0].Str  := 'll'#228'';
        a_2[0].Size := Length(a_2[0].Str);
        a_2[0].Index := -1;
        a_2[0].Result := -1;
        a_2[0].Method := nil;

        a_2[1].Str  := 'n'#228'';
        a_2[1].Size := Length(a_2[1].Str);
        a_2[1].Index := -1;
        a_2[1].Result := -1;
        a_2[1].Method := nil;

        a_2[2].Str  := 'ss'#228'';
        a_2[2].Size := Length(a_2[2].Str);
        a_2[2].Index := -1;
        a_2[2].Result := -1;
        a_2[2].Method := nil;

        a_2[3].Str  := 't'#228'';
        a_2[3].Size := Length(a_2[3].Str);
        a_2[3].Index := -1;
        a_2[3].Result := -1;
        a_2[3].Method := nil;

        a_2[4].Str  := 'lt'#228'';
        a_2[4].Size := Length(a_2[4].Str);
        a_2[4].Index := 3;
        a_2[4].Result := -1;
        a_2[4].Method := nil;

        a_2[5].Str  := 'st'#228'';
        a_2[5].Size := Length(a_2[5].Str);
        a_2[5].Index := 3;
        a_2[5].Result := -1;
        a_2[5].Method := nil;

    SetLength(a_3, 2);
        a_3[0].Str  := 'lle';
        a_3[0].Size := Length(a_3[0].Str);
        a_3[0].Index := -1;
        a_3[0].Result := -1;
        a_3[0].Method := nil;

        a_3[1].Str  := 'ine';
        a_3[1].Size := Length(a_3[1].Str);
        a_3[1].Index := -1;
        a_3[1].Result := -1;
        a_3[1].Method := nil;

    SetLength(a_4, 9);
        a_4[0].Str  := 'nsa';
        a_4[0].Size := Length(a_4[0].Str);
        a_4[0].Index := -1;
        a_4[0].Result := 3;
        a_4[0].Method := nil;

        a_4[1].Str  := 'mme';
        a_4[1].Size := Length(a_4[1].Str);
        a_4[1].Index := -1;
        a_4[1].Result := 3;
        a_4[1].Method := nil;

        a_4[2].Str  := 'nne';
        a_4[2].Size := Length(a_4[2].Str);
        a_4[2].Index := -1;
        a_4[2].Result := 3;
        a_4[2].Method := nil;

        a_4[3].Str  := 'ni';
        a_4[3].Size := Length(a_4[3].Str);
        a_4[3].Index := -1;
        a_4[3].Result := 2;
        a_4[3].Method := nil;

        a_4[4].Str  := 'si';
        a_4[4].Size := Length(a_4[4].Str);
        a_4[4].Index := -1;
        a_4[4].Result := 1;
        a_4[4].Method := nil;

        a_4[5].Str  := 'an';
        a_4[5].Size := Length(a_4[5].Str);
        a_4[5].Index := -1;
        a_4[5].Result := 4;
        a_4[5].Method := nil;

        a_4[6].Str  := 'en';
        a_4[6].Size := Length(a_4[6].Str);
        a_4[6].Index := -1;
        a_4[6].Result := 6;
        a_4[6].Method := nil;

        a_4[7].Str  := ''#228'n';
        a_4[7].Size := Length(a_4[7].Str);
        a_4[7].Index := -1;
        a_4[7].Result := 5;
        a_4[7].Method := nil;

        a_4[8].Str  := 'ns'#228'';
        a_4[8].Size := Length(a_4[8].Str);
        a_4[8].Index := -1;
        a_4[8].Result := 3;
        a_4[8].Method := nil;

    SetLength(a_5, 7);
        a_5[0].Str  := 'aa';
        a_5[0].Size := Length(a_5[0].Str);
        a_5[0].Index := -1;
        a_5[0].Result := -1;
        a_5[0].Method := nil;

        a_5[1].Str  := 'ee';
        a_5[1].Size := Length(a_5[1].Str);
        a_5[1].Index := -1;
        a_5[1].Result := -1;
        a_5[1].Method := nil;

        a_5[2].Str  := 'ii';
        a_5[2].Size := Length(a_5[2].Str);
        a_5[2].Index := -1;
        a_5[2].Result := -1;
        a_5[2].Method := nil;

        a_5[3].Str  := 'oo';
        a_5[3].Size := Length(a_5[3].Str);
        a_5[3].Index := -1;
        a_5[3].Result := -1;
        a_5[3].Method := nil;

        a_5[4].Str  := 'uu';
        a_5[4].Size := Length(a_5[4].Str);
        a_5[4].Index := -1;
        a_5[4].Result := -1;
        a_5[4].Method := nil;

        a_5[5].Str  := ''#228''#228'';
        a_5[5].Size := Length(a_5[5].Str);
        a_5[5].Index := -1;
        a_5[5].Result := -1;
        a_5[5].Method := nil;

        a_5[6].Str  := ''#246''#246'';
        a_5[6].Size := Length(a_5[6].Str);
        a_5[6].Index := -1;
        a_5[6].Result := -1;
        a_5[6].Method := nil;

    SetLength(a_6, 30);
        a_6[0].Str  := 'a';
        a_6[0].Size := Length(a_6[0].Str);
        a_6[0].Index := -1;
        a_6[0].Result := 8;
        a_6[0].Method := nil;

        a_6[1].Str  := 'lla';
        a_6[1].Size := Length(a_6[1].Str);
        a_6[1].Index := 0;
        a_6[1].Result := -1;
        a_6[1].Method := nil;

        a_6[2].Str  := 'na';
        a_6[2].Size := Length(a_6[2].Str);
        a_6[2].Index := 0;
        a_6[2].Result := -1;
        a_6[2].Method := nil;

        a_6[3].Str  := 'ssa';
        a_6[3].Size := Length(a_6[3].Str);
        a_6[3].Index := 0;
        a_6[3].Result := -1;
        a_6[3].Method := nil;

        a_6[4].Str  := 'ta';
        a_6[4].Size := Length(a_6[4].Str);
        a_6[4].Index := 0;
        a_6[4].Result := -1;
        a_6[4].Method := nil;

        a_6[5].Str  := 'lta';
        a_6[5].Size := Length(a_6[5].Str);
        a_6[5].Index := 4;
        a_6[5].Result := -1;
        a_6[5].Method := nil;

        a_6[6].Str  := 'sta';
        a_6[6].Size := Length(a_6[6].Str);
        a_6[6].Index := 4;
        a_6[6].Result := -1;
        a_6[6].Method := nil;

        a_6[7].Str  := 'tta';
        a_6[7].Size := Length(a_6[7].Str);
        a_6[7].Index := 4;
        a_6[7].Result := 9;
        a_6[7].Method := nil;

        a_6[8].Str  := 'lle';
        a_6[8].Size := Length(a_6[8].Str);
        a_6[8].Index := -1;
        a_6[8].Result := -1;
        a_6[8].Method := nil;

        a_6[9].Str  := 'ine';
        a_6[9].Size := Length(a_6[9].Str);
        a_6[9].Index := -1;
        a_6[9].Result := -1;
        a_6[9].Method := nil;

        a_6[10].Str  := 'ksi';
        a_6[10].Size := Length(a_6[10].Str);
        a_6[10].Index := -1;
        a_6[10].Result := -1;
        a_6[10].Method := nil;

        a_6[11].Str  := 'n';
        a_6[11].Size := Length(a_6[11].Str);
        a_6[11].Index := -1;
        a_6[11].Result := 7;
        a_6[11].Method := nil;

        a_6[12].Str  := 'han';
        a_6[12].Size := Length(a_6[12].Str);
        a_6[12].Index := 11;
        a_6[12].Result := 1;
        a_6[12].Method := nil;

        a_6[13].Str  := 'den';
        a_6[13].Size := Length(a_6[13].Str);
        a_6[13].Index := 11;
        a_6[13].Result := -1;
        a_6[13].Method := Self.r_VI;

        a_6[14].Str  := 'seen';
        a_6[14].Size := Length(a_6[14].Str);
        a_6[14].Index := 11;
        a_6[14].Result := -1;
        a_6[14].Method := Self.r_LONG;

        a_6[15].Str  := 'hen';
        a_6[15].Size := Length(a_6[15].Str);
        a_6[15].Index := 11;
        a_6[15].Result := 2;
        a_6[15].Method := nil;

        a_6[16].Str  := 'tten';
        a_6[16].Size := Length(a_6[16].Str);
        a_6[16].Index := 11;
        a_6[16].Result := -1;
        a_6[16].Method := Self.r_VI;

        a_6[17].Str  := 'hin';
        a_6[17].Size := Length(a_6[17].Str);
        a_6[17].Index := 11;
        a_6[17].Result := 3;
        a_6[17].Method := nil;

        a_6[18].Str  := 'siin';
        a_6[18].Size := Length(a_6[18].Str);
        a_6[18].Index := 11;
        a_6[18].Result := -1;
        a_6[18].Method := Self.r_VI;

        a_6[19].Str  := 'hon';
        a_6[19].Size := Length(a_6[19].Str);
        a_6[19].Index := 11;
        a_6[19].Result := 4;
        a_6[19].Method := nil;

        a_6[20].Str  := 'h'#228'n';
        a_6[20].Size := Length(a_6[20].Str);
        a_6[20].Index := 11;
        a_6[20].Result := 5;
        a_6[20].Method := nil;

        a_6[21].Str  := 'h'#246'n';
        a_6[21].Size := Length(a_6[21].Str);
        a_6[21].Index := 11;
        a_6[21].Result := 6;
        a_6[21].Method := nil;

        a_6[22].Str  := ''#228'';
        a_6[22].Size := Length(a_6[22].Str);
        a_6[22].Index := -1;
        a_6[22].Result := 8;
        a_6[22].Method := nil;

        a_6[23].Str  := 'll'#228'';
        a_6[23].Size := Length(a_6[23].Str);
        a_6[23].Index := 22;
        a_6[23].Result := -1;
        a_6[23].Method := nil;

        a_6[24].Str  := 'n'#228'';
        a_6[24].Size := Length(a_6[24].Str);
        a_6[24].Index := 22;
        a_6[24].Result := -1;
        a_6[24].Method := nil;

        a_6[25].Str  := 'ss'#228'';
        a_6[25].Size := Length(a_6[25].Str);
        a_6[25].Index := 22;
        a_6[25].Result := -1;
        a_6[25].Method := nil;

        a_6[26].Str  := 't'#228'';
        a_6[26].Size := Length(a_6[26].Str);
        a_6[26].Index := 22;
        a_6[26].Result := -1;
        a_6[26].Method := nil;

        a_6[27].Str  := 'lt'#228'';
        a_6[27].Size := Length(a_6[27].Str);
        a_6[27].Index := 26;
        a_6[27].Result := -1;
        a_6[27].Method := nil;

        a_6[28].Str  := 'st'#228'';
        a_6[28].Size := Length(a_6[28].Str);
        a_6[28].Index := 26;
        a_6[28].Result := -1;
        a_6[28].Method := nil;

        a_6[29].Str  := 'tt'#228'';
        a_6[29].Size := Length(a_6[29].Str);
        a_6[29].Index := 26;
        a_6[29].Result := 9;
        a_6[29].Method := nil;

    SetLength(a_7, 14);
        a_7[0].Str  := 'eja';
        a_7[0].Size := Length(a_7[0].Str);
        a_7[0].Index := -1;
        a_7[0].Result := -1;
        a_7[0].Method := nil;

        a_7[1].Str  := 'mma';
        a_7[1].Size := Length(a_7[1].Str);
        a_7[1].Index := -1;
        a_7[1].Result := 1;
        a_7[1].Method := nil;

        a_7[2].Str  := 'imma';
        a_7[2].Size := Length(a_7[2].Str);
        a_7[2].Index := 1;
        a_7[2].Result := -1;
        a_7[2].Method := nil;

        a_7[3].Str  := 'mpa';
        a_7[3].Size := Length(a_7[3].Str);
        a_7[3].Index := -1;
        a_7[3].Result := 1;
        a_7[3].Method := nil;

        a_7[4].Str  := 'impa';
        a_7[4].Size := Length(a_7[4].Str);
        a_7[4].Index := 3;
        a_7[4].Result := -1;
        a_7[4].Method := nil;

        a_7[5].Str  := 'mmi';
        a_7[5].Size := Length(a_7[5].Str);
        a_7[5].Index := -1;
        a_7[5].Result := 1;
        a_7[5].Method := nil;

        a_7[6].Str  := 'immi';
        a_7[6].Size := Length(a_7[6].Str);
        a_7[6].Index := 5;
        a_7[6].Result := -1;
        a_7[6].Method := nil;

        a_7[7].Str  := 'mpi';
        a_7[7].Size := Length(a_7[7].Str);
        a_7[7].Index := -1;
        a_7[7].Result := 1;
        a_7[7].Method := nil;

        a_7[8].Str  := 'impi';
        a_7[8].Size := Length(a_7[8].Str);
        a_7[8].Index := 7;
        a_7[8].Result := -1;
        a_7[8].Method := nil;

        a_7[9].Str  := 'ej'#228'';
        a_7[9].Size := Length(a_7[9].Str);
        a_7[9].Index := -1;
        a_7[9].Result := -1;
        a_7[9].Method := nil;

        a_7[10].Str  := 'mm'#228'';
        a_7[10].Size := Length(a_7[10].Str);
        a_7[10].Index := -1;
        a_7[10].Result := 1;
        a_7[10].Method := nil;

        a_7[11].Str  := 'imm'#228'';
        a_7[11].Size := Length(a_7[11].Str);
        a_7[11].Index := 10;
        a_7[11].Result := -1;
        a_7[11].Method := nil;

        a_7[12].Str  := 'mp'#228'';
        a_7[12].Size := Length(a_7[12].Str);
        a_7[12].Index := -1;
        a_7[12].Result := 1;
        a_7[12].Method := nil;

        a_7[13].Str  := 'imp'#228'';
        a_7[13].Size := Length(a_7[13].Str);
        a_7[13].Index := 12;
        a_7[13].Result := -1;
        a_7[13].Method := nil;

    SetLength(a_8, 2);
        a_8[0].Str  := 'i';
        a_8[0].Size := Length(a_8[0].Str);
        a_8[0].Index := -1;
        a_8[0].Result := -1;
        a_8[0].Method := nil;

        a_8[1].Str  := 'j';
        a_8[1].Size := Length(a_8[1].Str);
        a_8[1].Index := -1;
        a_8[1].Result := -1;
        a_8[1].Method := nil;

    SetLength(a_9, 2);
        a_9[0].Str  := 'mma';
        a_9[0].Size := Length(a_9[0].Str);
        a_9[0].Index := -1;
        a_9[0].Result := 1;
        a_9[0].Method := nil;

        a_9[1].Str  := 'imma';
        a_9[1].Size := Length(a_9[1].Str);
        a_9[1].Index := 0;
        a_9[1].Result := -1;
        a_9[1].Method := nil;

End;

Function TFinnishStemmer.r_mark_regions : Boolean;
Var
    C : Integer;
    v_1 : Integer;
    v_3 : Integer;
Label
    lab0,
    lab1,
    lab2,
    lab3,
    lab4,
    lab5,
    lab6,
    lab7;
Begin
    { (, line 41 }
    I_p1 := FLimit;
    I_p2 := FLimit;
    { goto, line 46 }
    While True Do
    Begin
        v_1 := FCursor;
        Repeat
            If (Not (InGrouping(g_v, 97, 246))) Then
            Begin
                goto lab1;
            End;
            FCursor := v_1;
            goto lab0;
        Until True;
lab1:
        FCursor := v_1;
        If (FCursor >= FLimit) Then
        Begin
            Begin Result := False; Exit; End;
        End;
        Inc(FCursor);
    End;
lab0:
    { gopast, line 46 }
    While True Do
    Begin
        Repeat
            If (Not (OutGrouping(g_v, 97, 246))) Then
            Begin
                goto lab3;
            End;
            goto lab2;
        Until True;
lab3:
        If (FCursor >= FLimit) Then
        Begin
            Begin Result := False; Exit; End;
        End;
        Inc(FCursor);
    End;
lab2:
    { setmark p1, line 46 }
    I_p1 := FCursor;
    { goto, line 47 }
    While True Do
    Begin
        v_3 := FCursor;
        Repeat
            If (Not (InGrouping(g_v, 97, 246))) Then
            Begin
                goto lab5;
            End;
            FCursor := v_3;
            goto lab4;
        Until True;
lab5:
        FCursor := v_3;
        If (FCursor >= FLimit) Then
        Begin
            Begin Result := False; Exit; End;
        End;
        Inc(FCursor);
    End;
lab4:
    { gopast, line 47 }
    While True Do
    Begin
        Repeat
            If (Not (OutGrouping(g_v, 97, 246))) Then
            Begin
                goto lab7;
            End;
            goto lab6;
        Until True;
lab7:
        If (FCursor >= FLimit) Then
        Begin
            Begin Result := False; Exit; End;
        End;
        Inc(FCursor);
    End;
lab6:
    { setmark p2, line 47 }
    I_p2 := FCursor;
    Result := True;
End;

Function TFinnishStemmer.r_R2 : Boolean;
Var
    C : Integer;
Begin
    If Not (I_p2 <= FCursor) Then
    Begin
        Begin Result := False; Exit; End;
    End;
    Result := True;
End;

Function TFinnishStemmer.r_particle_etc : Boolean;
Var
    C : Integer;
    AmongVar : Integer;
    v_1 : Integer;
    v_2 : Integer;
Begin
    { (, line 54 }
    { setlimit, line 55 }
    v_1 := FLimit - FCursor;
    { tomark, line 55 }
    If (FCursor < I_p1) Then
    Begin
        Begin Result := False; Exit; End;
    End;
    FCursor := I_p1;
    v_2 := FBkLimit;
    FBkLimit := FCursor;
    FCursor := FLimit - v_1;
    { (, line 55 }
    { [, line 55 }
    FKet := FCursor;
    { substring, line 55 }
    AmongVar := FindAmongBk(a_0, 10);
    If (AmongVar = 0) Then
    Begin
        FBkLimit := v_2;
        Begin Result := False; Exit; End;
    End;
    { ], line 55 }
    FBra := FCursor;
    FBkLimit := v_2;
    Case AmongVar Of
        0:
        Begin
            Begin Result := False; Exit; End;
        End;
        1:
        Begin
            { (, line 62 }
            If (Not (InGroupingBk(g_particle_end, 97, 246))) Then
            Begin
                Begin Result := False; Exit; End;
            End;
        End;
        2:
        Begin
            { (, line 64 }
            { call R2, line 64 }
            If (Not r_R2) Then
            Begin
                Begin Result := False; Exit; End;
            End;
        End;
    End;
    { delete, line 66 }
    SliceDel;
    Result := True;
End;

Function TFinnishStemmer.r_possessive : Boolean;
Var
    C : Integer;
    AmongVar : Integer;
    v_1 : Integer;
    v_2 : Integer;
    v_3 : Integer;
Label
    lab0;
Begin
    { (, line 68 }
    { setlimit, line 69 }
    v_1 := FLimit - FCursor;
    { tomark, line 69 }
    If (FCursor < I_p1) Then
    Begin
        Begin Result := False; Exit; End;
    End;
    FCursor := I_p1;
    v_2 := FBkLimit;
    FBkLimit := FCursor;
    FCursor := FLimit - v_1;
    { (, line 69 }
    { [, line 69 }
    FKet := FCursor;
    { substring, line 69 }
    AmongVar := FindAmongBk(a_4, 9);
    If (AmongVar = 0) Then
    Begin
        FBkLimit := v_2;
        Begin Result := False; Exit; End;
    End;
    { ], line 69 }
    FBra := FCursor;
    FBkLimit := v_2;
    Case AmongVar Of
        0:
        Begin
            Begin Result := False; Exit; End;
        End;
        1:
        Begin
            { (, line 72 }
            { not, line 72 }
            Begin
                v_3 := FLimit - FCursor;
                Repeat
                    { literal, line 72 }
                    If (Not (EqSBk(1, 'k'))) Then
                    Begin
                        goto lab0;
                    End;
                    Begin Result := False; Exit; End;
                Until True;
lab0:
                FCursor := FLimit - v_3;
            End;
            { delete, line 72 }
            SliceDel;
        End;
        2:
        Begin
            { (, line 74 }
            { delete, line 74 }
            SliceDel;
            { [, line 74 }
            FKet := FCursor;
            { literal, line 74 }
            If (Not (EqSBk(3, 'kse'))) Then
            Begin
                Begin Result := False; Exit; End;
            End;
            { ], line 74 }
            FBra := FCursor;
            { <-, line 74 }
            SliceFrom('ksi');
        End;
        3:
        Begin
            { (, line 78 }
            { delete, line 78 }
            SliceDel;
        End;
        4:
        Begin
            { (, line 81 }
            { among, line 81 }
            If (FindAmongBk(a_1, 6) = 0) Then
            Begin
                Begin Result := False; Exit; End;
            End;
            { delete, line 81 }
            SliceDel;
        End;
        5:
        Begin
            { (, line 83 }
            { among, line 83 }
            If (FindAmongBk(a_2, 6) = 0) Then
            Begin
                Begin Result := False; Exit; End;
            End;
            { delete, line 84 }
            SliceDel;
        End;
        6:
        Begin
            { (, line 86 }
            { among, line 86 }
            If (FindAmongBk(a_3, 2) = 0) Then
            Begin
                Begin Result := False; Exit; End;
            End;
            { delete, line 86 }
            SliceDel;
        End;
    End;
    Result := True;
End;

Function TFinnishStemmer.r_LONG : Boolean;
Var
    C : Integer;
Begin
    { among, line 91 }
    If (FindAmongBk(a_5, 7) = 0) Then
    Begin
        Begin Result := False; Exit; End;
    End;
    Result := True;
End;

Function TFinnishStemmer.r_VI : Boolean;
Var
    C : Integer;
Begin
    { (, line 93 }
    { literal, line 93 }
    If (Not (EqSBk(1, 'i'))) Then
    Begin
        Begin Result := False; Exit; End;
    End;
    If (Not (InGroupingBk(g_V2, 97, 246))) Then
    Begin
        Begin Result := False; Exit; End;
    End;
    Result := True;
End;

Function TFinnishStemmer.r_case : Boolean;
Var
    C : Integer;
    AmongVar : Integer;
    v_1 : Integer;
    v_2 : Integer;
    v_3 : Integer;
    v_4 : Integer;
    v_5 : Integer;
Label
    lab0,
    lab1,
    lab2;
Begin
    { (, line 95 }
    { setlimit, line 96 }
    v_1 := FLimit - FCursor;
    { tomark, line 96 }
    If (FCursor < I_p1) Then
    Begin
        Begin Result := False; Exit; End;
    End;
    FCursor := I_p1;
    v_2 := FBkLimit;
    FBkLimit := FCursor;
    FCursor := FLimit - v_1;
    { (, line 96 }
    { [, line 96 }
    FKet := FCursor;
    { substring, line 96 }
    AmongVar := FindAmongBk(a_6, 30);
    If (AmongVar = 0) Then
    Begin
        FBkLimit := v_2;
        Begin Result := False; Exit; End;
    End;
    { ], line 96 }
    FBra := FCursor;
    FBkLimit := v_2;
    Case AmongVar Of
        0:
        Begin
            Begin Result := False; Exit; End;
        End;
        1:
        Begin
            { (, line 98 }
            { literal, line 98 }
            If (Not (EqSBk(1, 'a'))) Then
            Begin
                Begin Result := False; Exit; End;
            End;
        End;
        2:
        Begin
            { (, line 99 }
            { literal, line 99 }
            If (Not (EqSBk(1, 'e'))) Then
            Begin
                Begin Result := False; Exit; End;
            End;
        End;
        3:
        Begin
            { (, line 100 }
            { literal, line 100 }
            If (Not (EqSBk(1, 'i'))) Then
            Begin
                Begin Result := False; Exit; End;
            End;
        End;
        4:
        Begin
            { (, line 101 }
            { literal, line 101 }
            If (Not (EqSBk(1, 'o'))) Then
            Begin
                Begin Result := False; Exit; End;
            End;
        End;
        5:
        Begin
            { (, line 102 }
            { literal, line 102 }
            If (Not (EqSBk(1, ''#228''))) Then
            Begin
                Begin Result := False; Exit; End;
            End;
        End;
        6:
        Begin
            { (, line 103 }
            { literal, line 103 }
            If (Not (EqSBk(1, ''#246''))) Then
            Begin
                Begin Result := False; Exit; End;
            End;
        End;
        7:
        Begin
            { (, line 111 }
            { try, line 111 }
            v_3 := FLimit - FCursor;
            Repeat
                { (, line 111 }
                { and, line 113 }
                v_4 := FLimit - FCursor;
                { or, line 112 }
                Repeat
                    v_5 := FLimit - FCursor;
                    Repeat
                        { call LONG, line 111 }
                        If (Not r_LONG) Then
                        Begin
                            goto lab2;
                        End;
                        goto lab1;
                    Until True;
lab2:
                    FCursor := FLimit - v_5;
                    { literal, line 112 }
                    If (Not (EqSBk(2, 'ie'))) Then
                    Begin
                        FCursor := FLimit - v_3;
                        goto lab0;
                    End;
                Until True;
lab1:
                FCursor := FLimit - v_4;
                { next, line 113 }
                If (FCursor <= FBkLimit) Then
                Begin
                    FCursor := FLimit - v_3;
                    goto lab0;
                End;
                Dec(FCursor);
                { ], line 113 }
                FBra := FCursor;
            Until True;
lab0:
        End;
        8:
        Begin
            { (, line 119 }
            If (Not (InGroupingBk(g_v, 97, 246))) Then
            Begin
                Begin Result := False; Exit; End;
            End;
            If (Not (OutGroupingBk(g_v, 97, 246))) Then
            Begin
                Begin Result := False; Exit; End;
            End;
        End;
        9:
        Begin
            { (, line 121 }
            { literal, line 121 }
            If (Not (EqSBk(1, 'e'))) Then
            Begin
                Begin Result := False; Exit; End;
            End;
        End;
    End;
    { delete, line 138 }
    SliceDel;
    { set ending_removed, line 139 }
    B_ending_removed := True;
    Result := True;
End;

Function TFinnishStemmer.r_other_endings : Boolean;
Var
    C : Integer;
    AmongVar : Integer;
    v_1 : Integer;
    v_2 : Integer;
    v_3 : Integer;
Label
    lab0;
Begin
    { (, line 141 }
    { setlimit, line 142 }
    v_1 := FLimit - FCursor;
    { tomark, line 142 }
    If (FCursor < I_p2) Then
    Begin
        Begin Result := False; Exit; End;
    End;
    FCursor := I_p2;
    v_2 := FBkLimit;
    FBkLimit := FCursor;
    FCursor := FLimit - v_1;
    { (, line 142 }
    { [, line 142 }
    FKet := FCursor;
    { substring, line 142 }
    AmongVar := FindAmongBk(a_7, 14);
    If (AmongVar = 0) Then
    Begin
        FBkLimit := v_2;
        Begin Result := False; Exit; End;
    End;
    { ], line 142 }
    FBra := FCursor;
    FBkLimit := v_2;
    Case AmongVar Of
        0:
        Begin
            Begin Result := False; Exit; End;
        End;
        1:
        Begin
            { (, line 146 }
            { not, line 146 }
            Begin
                v_3 := FLimit - FCursor;
                Repeat
                    { literal, line 146 }
                    If (Not (EqSBk(2, 'po'))) Then
                    Begin
                        goto lab0;
                    End;
                    Begin Result := False; Exit; End;
                Until True;
lab0:
                FCursor := FLimit - v_3;
            End;
        End;
    End;
    { delete, line 151 }
    SliceDel;
    Result := True;
End;

Function TFinnishStemmer.r_i_plural : Boolean;
Var
    C : Integer;
    v_1 : Integer;
    v_2 : Integer;
Begin
    { (, line 153 }
    { setlimit, line 154 }
    v_1 := FLimit - FCursor;
    { tomark, line 154 }
    If (FCursor < I_p1) Then
    Begin
        Begin Result := False; Exit; End;
    End;
    FCursor := I_p1;
    v_2 := FBkLimit;
    FBkLimit := FCursor;
    FCursor := FLimit - v_1;
    { (, line 154 }
    { [, line 154 }
    FKet := FCursor;
    { substring, line 154 }
    If (FindAmongBk(a_8, 2) = 0) Then
    Begin
        FBkLimit := v_2;
        Begin Result := False; Exit; End;
    End;
    { ], line 154 }
    FBra := FCursor;
    FBkLimit := v_2;
    { delete, line 158 }
    SliceDel;
    Result := True;
End;

Function TFinnishStemmer.r_t_plural : Boolean;
Var
    C : Integer;
    AmongVar : Integer;
    v_1 : Integer;
    v_2 : Integer;
    v_3 : Integer;
    v_4 : Integer;
    v_5 : Integer;
    v_6 : Integer;
Label
    lab0;
Begin
    { (, line 160 }
    { setlimit, line 161 }
    v_1 := FLimit - FCursor;
    { tomark, line 161 }
    If (FCursor < I_p1) Then
    Begin
        Begin Result := False; Exit; End;
    End;
    FCursor := I_p1;
    v_2 := FBkLimit;
    FBkLimit := FCursor;
    FCursor := FLimit - v_1;
    { (, line 161 }
    { [, line 162 }
    FKet := FCursor;
    { literal, line 162 }
    If (Not (EqSBk(1, 't'))) Then
    Begin
        FBkLimit := v_2;
        Begin Result := False; Exit; End;
    End;
    { ], line 162 }
    FBra := FCursor;
    { test, line 162 }
    v_3 := FLimit - FCursor;
    If (Not (InGroupingBk(g_v, 97, 246))) Then
    Begin
        FBkLimit := v_2;
        Begin Result := False; Exit; End;
    End;
    FCursor := FLimit - v_3;
    { delete, line 163 }
    SliceDel;
    FBkLimit := v_2;
    { setlimit, line 165 }
    v_4 := FLimit - FCursor;
    { tomark, line 165 }
    If (FCursor < I_p2) Then
    Begin
        Begin Result := False; Exit; End;
    End;
    FCursor := I_p2;
    v_5 := FBkLimit;
    FBkLimit := FCursor;
    FCursor := FLimit - v_4;
    { (, line 165 }
    { [, line 165 }
    FKet := FCursor;
    { substring, line 165 }
    AmongVar := FindAmongBk(a_9, 2);
    If (AmongVar = 0) Then
    Begin
        FBkLimit := v_5;
        Begin Result := False; Exit; End;
    End;
    { ], line 165 }
    FBra := FCursor;
    FBkLimit := v_5;
    Case AmongVar Of
        0:
        Begin
            Begin Result := False; Exit; End;
        End;
        1:
        Begin
            { (, line 167 }
            { not, line 167 }
            Begin
                v_6 := FLimit - FCursor;
                Repeat
                    { literal, line 167 }
                    If (Not (EqSBk(2, 'po'))) Then
                    Begin
                        goto lab0;
                    End;
                    Begin Result := False; Exit; End;
                Until True;
lab0:
                FCursor := FLimit - v_6;
            End;
        End;
    End;
    { delete, line 170 }
    SliceDel;
    Result := True;
End;

Function TFinnishStemmer.r_tidy : Boolean;
Var
    C : Integer;
    v_1 : Integer;
    v_2 : Integer;
    v_3 : Integer;
    v_4 : Integer;
    v_5 : Integer;
    v_6 : Integer;
    v_7 : Integer;
    v_8 : Integer;
    v_9 : Integer;
Label
    lab0,
    lab1,
    lab2,
    lab3,
    lab4,
    lab5,
    lab6,
    lab7;
Begin
    { (, line 172 }
    { setlimit, line 173 }
    v_1 := FLimit - FCursor;
    { tomark, line 173 }
    If (FCursor < I_p1) Then
    Begin
        Begin Result := False; Exit; End;
    End;
    FCursor := I_p1;
    v_2 := FBkLimit;
    FBkLimit := FCursor;
    FCursor := FLimit - v_1;
    { (, line 173 }
    { do, line 174 }
    v_3 := FLimit - FCursor;
    Repeat
        { (, line 174 }
        { and, line 174 }
        v_4 := FLimit - FCursor;
        { call LONG, line 174 }
        If (Not r_LONG) Then
        Begin
            goto lab0;
        End;
        FCursor := FLimit - v_4;
        { (, line 174 }
        { [, line 174 }
        FKet := FCursor;
        { next, line 174 }
        If (FCursor <= FBkLimit) Then
        Begin
            goto lab0;
        End;
        Dec(FCursor);
        { ], line 174 }
        FBra := FCursor;
        { delete, line 174 }
        SliceDel;
    Until True;
lab0:
    FCursor := FLimit - v_3;
    { do, line 175 }
    v_5 := FLimit - FCursor;
    Repeat
        { (, line 175 }
        { [, line 175 }
        FKet := FCursor;
        If (Not (InGroupingBk(g_AEI, 97, 228))) Then
        Begin
            goto lab1;
        End;
        { ], line 175 }
        FBra := FCursor;
        If (Not (OutGroupingBk(g_v, 97, 246))) Then
        Begin
            goto lab1;
        End;
        { delete, line 175 }
        SliceDel;
    Until True;
lab1:
    FCursor := FLimit - v_5;
    { do, line 176 }
    v_6 := FLimit - FCursor;
    Repeat
        { (, line 176 }
        { [, line 176 }
        FKet := FCursor;
        { literal, line 176 }
        If (Not (EqSBk(1, 'j'))) Then
        Begin
            goto lab2;
        End;
        { ], line 176 }
        FBra := FCursor;
        { or, line 176 }
        Repeat
            v_7 := FLimit - FCursor;
            Repeat
                { literal, line 176 }
                If (Not (EqSBk(1, 'o'))) Then
                Begin
                    goto lab4;
                End;
                goto lab3;
            Until True;
lab4:
            FCursor := FLimit - v_7;
            { literal, line 176 }
            If (Not (EqSBk(1, 'u'))) Then
            Begin
                goto lab2;
            End;
        Until True;
lab3:
        { delete, line 176 }
        SliceDel;
    Until True;
lab2:
    FCursor := FLimit - v_6;
    { do, line 177 }
    v_8 := FLimit - FCursor;
    Repeat
        { (, line 177 }
        { [, line 177 }
        FKet := FCursor;
        { literal, line 177 }
        If (Not (EqSBk(1, 'o'))) Then
        Begin
            goto lab5;
        End;
        { ], line 177 }
        FBra := FCursor;
        { literal, line 177 }
        If (Not (EqSBk(1, 'j'))) Then
        Begin
            goto lab5;
        End;
        { delete, line 177 }
        SliceDel;
    Until True;
lab5:
    FCursor := FLimit - v_8;
    FBkLimit := v_2;
    { goto, line 179 }
    While True Do
    Begin
        v_9 := FLimit - FCursor;
        Repeat
            If (Not (OutGroupingBk(g_v, 97, 246))) Then
            Begin
                goto lab7;
            End;
            FCursor := FLimit - v_9;
            goto lab6;
        Until True;
lab7:
        FCursor := FLimit - v_9;
        If (FCursor <= FBkLimit) Then
        Begin
            Begin Result := False; Exit; End;
        End;
        Dec(FCursor);
    End;
lab6:
    { [, line 179 }
    FKet := FCursor;
    { next, line 179 }
    If (FCursor <= FBkLimit) Then
    Begin
        Begin Result := False; Exit; End;
    End;
    Dec(FCursor);
    { ], line 179 }
    FBra := FCursor;
    { -> x, line 179 }
    S_x := SliceTo(S_x);
    { name x, line 179 }
    If (Not (EqVBk(S_x))) Then
    Begin
        Begin Result := False; Exit; End;
    End;
    { delete, line 179 }
    SliceDel;
    Result := True;
End;

Function TFinnishStemmer.stem : Boolean;
Var
    C : Integer;
    v_1 : Integer;
    v_2 : Integer;
    v_3 : Integer;
    v_4 : Integer;
    v_5 : Integer;
    v_6 : Integer;
    v_7 : Integer;
    v_8 : Integer;
    v_9 : Integer;
Label
    lab0,
    lab1,
    lab2,
    lab3,
    lab4,
    lab5,
    lab6,
    lab7,
    lab8,
    lab9;
Begin
    { (, line 183 }
    { do, line 185 }
    v_1 := FCursor;
    Repeat
        { call mark_regions, line 185 }
        If (Not r_mark_regions) Then
        Begin
            goto lab0;
        End;
    Until True;
lab0:
    FCursor := v_1;
    { unset ending_removed, line 186 }
    B_ending_removed := False;
    { backwards, line 187 }
    FBkLimit := FCursor; FCursor := FLimit;
    { (, line 187 }
    { do, line 188 }
    v_2 := FLimit - FCursor;
    Repeat
        { call particle_etc, line 188 }
        If (Not r_particle_etc) Then
        Begin
            goto lab1;
        End;
    Until True;
lab1:
    FCursor := FLimit - v_2;
    { do, line 189 }
    v_3 := FLimit - FCursor;
    Repeat
        { call possessive, line 189 }
        If (Not r_possessive) Then
        Begin
            goto lab2;
        End;
    Until True;
lab2:
    FCursor := FLimit - v_3;
    { do, line 190 }
    v_4 := FLimit - FCursor;
    Repeat
        { call case, line 190 }
        If (Not r_case) Then
        Begin
            goto lab3;
        End;
    Until True;
lab3:
    FCursor := FLimit - v_4;
    { do, line 191 }
    v_5 := FLimit - FCursor;
    Repeat
        { call other_endings, line 191 }
        If (Not r_other_endings) Then
        Begin
            goto lab4;
        End;
    Until True;
lab4:
    FCursor := FLimit - v_5;
    { or, line 192 }
    Repeat
        v_6 := FLimit - FCursor;
        Repeat
            { (, line 192 }
            { Boolean test ending_removed, line 192 }
            If (Not (B_ending_removed)) Then
            Begin
                goto lab6;
            End;
            { do, line 192 }
            v_7 := FLimit - FCursor;
            Repeat
                { call i_plural, line 192 }
                If (Not r_i_plural) Then
                Begin
                    goto lab7;
                End;
            Until True;
lab7:
            FCursor := FLimit - v_7;
            goto lab5;
        Until True;
lab6:
        FCursor := FLimit - v_6;
        { do, line 192 }
        v_8 := FLimit - FCursor;
        Repeat
            { call t_plural, line 192 }
            If (Not r_t_plural) Then
            Begin
                goto lab8;
            End;
        Until True;
lab8:
        FCursor := FLimit - v_8;
    Until True;
lab5:
    { do, line 193 }
    v_9 := FLimit - FCursor;
    Repeat
        { call tidy, line 193 }
        If (Not r_tidy) Then
        Begin
            goto lab9;
        End;
    Until True;
lab9:
    FCursor := FLimit - v_9;
    FCursor := FBkLimit;    Result := True;
End;

End.
