{ This file was generated automatically by the Snowball to Delphi compiler. }

Unit German2Stemmer;

{$HINTS OFF}

Interface

Uses SnowballProgram;

Type
    TGerman2Stemmer = Class(TSnowballProgram)
    private
        I_p2 : Integer;
        I_p1 : Integer;
    private
        a_0 : Array Of TAmong;
        a_1 : Array Of TAmong;
        a_2 : Array Of TAmong;
        a_3 : Array Of TAmong;
        a_4 : Array Of TAmong;
        a_5 : Array Of TAmong;
    public
        Constructor Create;
        Function stem : Boolean;
    private
        Function r_prelude : Boolean;
        Function r_mark_regions : Boolean;
        Function r_postlude : Boolean;
        Function r_R1 : Boolean;
        Function r_R2 : Boolean;
        Function r_standard_suffix : Boolean;
End;

Implementation

Const
    g_v : Array [0..19] Of Char = (
        Chr(17),
        Chr(65),
        Chr(16),
        Chr(1),
        Chr(0),
        Chr(0),
        Chr(0),
        Chr(0),
        Chr(0),
        Chr(0),
        Chr(0),
        Chr(0),
        Chr(0),
        Chr(0),
        Chr(0),
        Chr(0),
        Chr(8),
        Chr(0),
        Chr(32),
        Chr(8)
    );

Const
    g_s_ending : Array [0..2] Of Char = (
        Chr(117),
        Chr(30),
        Chr(5)
    );

Const
    g_st_ending : Array [0..2] Of Char = (
        Chr(117),
        Chr(30),
        Chr(4)
    );

Constructor TGerman2Stemmer.Create;
Begin
    SetLength(a_0, 6);
        a_0[0].Str  := '';
        a_0[0].Size := Length(a_0[0].Str);
        a_0[0].Index := -1;
        a_0[0].Result := 6;
        a_0[0].Method := nil;

        a_0[1].Str  := 'ae';
        a_0[1].Size := Length(a_0[1].Str);
        a_0[1].Index := 0;
        a_0[1].Result := 2;
        a_0[1].Method := nil;

        a_0[2].Str  := 'oe';
        a_0[2].Size := Length(a_0[2].Str);
        a_0[2].Index := 0;
        a_0[2].Result := 3;
        a_0[2].Method := nil;

        a_0[3].Str  := 'qu';
        a_0[3].Size := Length(a_0[3].Str);
        a_0[3].Index := 0;
        a_0[3].Result := 5;
        a_0[3].Method := nil;

        a_0[4].Str  := 'ue';
        a_0[4].Size := Length(a_0[4].Str);
        a_0[4].Index := 0;
        a_0[4].Result := 4;
        a_0[4].Method := nil;

        a_0[5].Str  := ''#223'';
        a_0[5].Size := Length(a_0[5].Str);
        a_0[5].Index := 0;
        a_0[5].Result := 1;
        a_0[5].Method := nil;

    SetLength(a_1, 6);
        a_1[0].Str  := '';
        a_1[0].Size := Length(a_1[0].Str);
        a_1[0].Index := -1;
        a_1[0].Result := 6;
        a_1[0].Method := nil;

        a_1[1].Str  := 'U';
        a_1[1].Size := Length(a_1[1].Str);
        a_1[1].Index := 0;
        a_1[1].Result := 2;
        a_1[1].Method := nil;

        a_1[2].Str  := 'Y';
        a_1[2].Size := Length(a_1[2].Str);
        a_1[2].Index := 0;
        a_1[2].Result := 1;
        a_1[2].Method := nil;

        a_1[3].Str  := ''#228'';
        a_1[3].Size := Length(a_1[3].Str);
        a_1[3].Index := 0;
        a_1[3].Result := 3;
        a_1[3].Method := nil;

        a_1[4].Str  := ''#246'';
        a_1[4].Size := Length(a_1[4].Str);
        a_1[4].Index := 0;
        a_1[4].Result := 4;
        a_1[4].Method := nil;

        a_1[5].Str  := ''#252'';
        a_1[5].Size := Length(a_1[5].Str);
        a_1[5].Index := 0;
        a_1[5].Result := 5;
        a_1[5].Method := nil;

    SetLength(a_2, 7);
        a_2[0].Str  := 'e';
        a_2[0].Size := Length(a_2[0].Str);
        a_2[0].Index := -1;
        a_2[0].Result := 1;
        a_2[0].Method := nil;

        a_2[1].Str  := 'em';
        a_2[1].Size := Length(a_2[1].Str);
        a_2[1].Index := -1;
        a_2[1].Result := 1;
        a_2[1].Method := nil;

        a_2[2].Str  := 'en';
        a_2[2].Size := Length(a_2[2].Str);
        a_2[2].Index := -1;
        a_2[2].Result := 1;
        a_2[2].Method := nil;

        a_2[3].Str  := 'ern';
        a_2[3].Size := Length(a_2[3].Str);
        a_2[3].Index := -1;
        a_2[3].Result := 1;
        a_2[3].Method := nil;

        a_2[4].Str  := 'er';
        a_2[4].Size := Length(a_2[4].Str);
        a_2[4].Index := -1;
        a_2[4].Result := 1;
        a_2[4].Method := nil;

        a_2[5].Str  := 's';
        a_2[5].Size := Length(a_2[5].Str);
        a_2[5].Index := -1;
        a_2[5].Result := 2;
        a_2[5].Method := nil;

        a_2[6].Str  := 'es';
        a_2[6].Size := Length(a_2[6].Str);
        a_2[6].Index := 5;
        a_2[6].Result := 1;
        a_2[6].Method := nil;

    SetLength(a_3, 4);
        a_3[0].Str  := 'en';
        a_3[0].Size := Length(a_3[0].Str);
        a_3[0].Index := -1;
        a_3[0].Result := 1;
        a_3[0].Method := nil;

        a_3[1].Str  := 'er';
        a_3[1].Size := Length(a_3[1].Str);
        a_3[1].Index := -1;
        a_3[1].Result := 1;
        a_3[1].Method := nil;

        a_3[2].Str  := 'st';
        a_3[2].Size := Length(a_3[2].Str);
        a_3[2].Index := -1;
        a_3[2].Result := 2;
        a_3[2].Method := nil;

        a_3[3].Str  := 'est';
        a_3[3].Size := Length(a_3[3].Str);
        a_3[3].Index := 2;
        a_3[3].Result := 1;
        a_3[3].Method := nil;

    SetLength(a_4, 2);
        a_4[0].Str  := 'ig';
        a_4[0].Size := Length(a_4[0].Str);
        a_4[0].Index := -1;
        a_4[0].Result := 1;
        a_4[0].Method := nil;

        a_4[1].Str  := 'lich';
        a_4[1].Size := Length(a_4[1].Str);
        a_4[1].Index := -1;
        a_4[1].Result := 1;
        a_4[1].Method := nil;

    SetLength(a_5, 8);
        a_5[0].Str  := 'end';
        a_5[0].Size := Length(a_5[0].Str);
        a_5[0].Index := -1;
        a_5[0].Result := 1;
        a_5[0].Method := nil;

        a_5[1].Str  := 'ig';
        a_5[1].Size := Length(a_5[1].Str);
        a_5[1].Index := -1;
        a_5[1].Result := 2;
        a_5[1].Method := nil;

        a_5[2].Str  := 'ung';
        a_5[2].Size := Length(a_5[2].Str);
        a_5[2].Index := -1;
        a_5[2].Result := 1;
        a_5[2].Method := nil;

        a_5[3].Str  := 'lich';
        a_5[3].Size := Length(a_5[3].Str);
        a_5[3].Index := -1;
        a_5[3].Result := 3;
        a_5[3].Method := nil;

        a_5[4].Str  := 'isch';
        a_5[4].Size := Length(a_5[4].Str);
        a_5[4].Index := -1;
        a_5[4].Result := 2;
        a_5[4].Method := nil;

        a_5[5].Str  := 'ik';
        a_5[5].Size := Length(a_5[5].Str);
        a_5[5].Index := -1;
        a_5[5].Result := 2;
        a_5[5].Method := nil;

        a_5[6].Str  := 'heit';
        a_5[6].Size := Length(a_5[6].Str);
        a_5[6].Index := -1;
        a_5[6].Result := 3;
        a_5[6].Method := nil;

        a_5[7].Str  := 'keit';
        a_5[7].Size := Length(a_5[7].Str);
        a_5[7].Index := -1;
        a_5[7].Result := 4;
        a_5[7].Method := nil;

End;

Function TGerman2Stemmer.r_prelude : Boolean;
Var
    C : Integer;
    AmongVar : Integer;
    v_1 : Integer;
    v_2 : Integer;
    v_3 : Integer;
    v_4 : Integer;
    v_5 : Integer;
Label
    lab0,
    lab1,
    lab2,
    lab3,
    lab4,
    lab5,
    lab6,
    lab7;
Begin
    { (, line 28 }
    { test, line 30 }
    v_1 := FCursor;
    { repeat, line 30 }
lab0:
    While True Do
    Begin
        v_2 := FCursor;
        Repeat
            { goto, line 30 }
            While True Do
            Begin
                v_3 := FCursor;
                Repeat
                    { (, line 30 }
                    If (Not (InGrouping(g_v, 97, 252))) Then
                    Begin
                        goto lab3;
                    End;
                    { [, line 31 }
                    FBra := FCursor;
                    { or, line 31 }
                    Repeat
                        v_4 := FCursor;
                        Repeat
                            { (, line 31 }
                            { literal, line 31 }
                            If (Not (EqS(1, 'u'))) Then
                            Begin
                                goto lab5;
                            End;
                            { ], line 31 }
                            FKet := FCursor;
                            If (Not (InGrouping(g_v, 97, 252))) Then
                            Begin
                                goto lab5;
                            End;
                            { <-, line 31 }
                            SliceFrom('U');
                            goto lab4;
                        Until True;
lab5:
                        FCursor := v_4;
                        { (, line 32 }
                        { literal, line 32 }
                        If (Not (EqS(1, 'y'))) Then
                        Begin
                            goto lab3;
                        End;
                        { ], line 32 }
                        FKet := FCursor;
                        If (Not (InGrouping(g_v, 97, 252))) Then
                        Begin
                            goto lab3;
                        End;
                        { <-, line 32 }
                        SliceFrom('Y');
                    Until True;
lab4:
                    FCursor := v_3;
                    goto lab2;
                Until True;
lab3:
                FCursor := v_3;
                If (FCursor >= FLimit) Then
                Begin
                    goto lab1;
                End;
                Inc(FCursor);
            End;
lab2:
            goto lab0;
        Until True;
lab1:
        FCursor := v_2;
        Break;
    End;
    FCursor := v_1;
    { repeat, line 35 }
lab6:
    While True Do
    Begin
        v_5 := FCursor;
        Repeat
            { (, line 35 }
            { [, line 36 }
            FBra := FCursor;
            { substring, line 36 }
            AmongVar := FindAmong(a_0, 6);
            If (AmongVar = 0) Then
            Begin
                goto lab7;
            End;
            { ], line 36 }
            FKet := FCursor;
            Case AmongVar Of
                0:
                Begin
                    goto lab7;
                End;
                1:
                Begin
                    { (, line 37 }
                    { <-, line 37 }
                    SliceFrom('ss');
                End;
                2:
                Begin
                    { (, line 38 }
                    { <-, line 38 }
                    SliceFrom(''#228'');
                End;
                3:
                Begin
                    { (, line 39 }
                    { <-, line 39 }
                    SliceFrom(''#246'');
                End;
                4:
                Begin
                    { (, line 40 }
                    { <-, line 40 }
                    SliceFrom(''#252'');
                End;
                5:
                Begin
                    { (, line 41 }
                    { hop, line 41 }
                    Begin
                        C := FCursor + 2;
                        If ((0 > C) Or (C > FLimit)) Then
                        Begin
                            goto lab7;
                        End;
                        FCursor := c;
                    End;
                End;
                6:
                Begin
                    { (, line 42 }
                    { next, line 42 }
                    If (FCursor >= FLimit) Then
                    Begin
                        goto lab7;
                    End;
                    Inc(FCursor);
                End;
            End;
            goto lab6;
        Until True;
lab7:
        FCursor := v_5;
        Break;
    End;
    Result := True;
End;

Function TGerman2Stemmer.r_mark_regions : Boolean;
Var
    C : Integer;
Label
    lab0,
    lab1,
    lab2,
    lab3,
    lab4,
    lab5,
    lab6,
    lab7,
    lab8;
Begin
    { (, line 48 }
    I_p1 := FLimit;
    I_p2 := FLimit;
    { gopast, line 53 }
    While True Do
    Begin
        Repeat
            If (Not (InGrouping(g_v, 97, 252))) Then
            Begin
                goto lab1;
            End;
            goto lab0;
        Until True;
lab1:
        If (FCursor >= FLimit) Then
        Begin
            Begin Result := False; Exit; End;
        End;
        Inc(FCursor);
    End;
lab0:
    { gopast, line 53 }
    While True Do
    Begin
        Repeat
            If (Not (OutGrouping(g_v, 97, 252))) Then
            Begin
                goto lab3;
            End;
            goto lab2;
        Until True;
lab3:
        If (FCursor >= FLimit) Then
        Begin
            Begin Result := False; Exit; End;
        End;
        Inc(FCursor);
    End;
lab2:
    { setmark p1, line 53 }
    I_p1 := FCursor;
    { try, line 54 }
    Repeat
        { (, line 54 }
        If Not (I_p1 < 3) Then
        Begin
            goto lab4;
        End;
        I_p1 := 3;
    Until True;
lab4:
    { gopast, line 55 }
    While True Do
    Begin
        Repeat
            If (Not (InGrouping(g_v, 97, 252))) Then
            Begin
                goto lab6;
            End;
            goto lab5;
        Until True;
lab6:
        If (FCursor >= FLimit) Then
        Begin
            Begin Result := False; Exit; End;
        End;
        Inc(FCursor);
    End;
lab5:
    { gopast, line 55 }
    While True Do
    Begin
        Repeat
            If (Not (OutGrouping(g_v, 97, 252))) Then
            Begin
                goto lab8;
            End;
            goto lab7;
        Until True;
lab8:
        If (FCursor >= FLimit) Then
        Begin
            Begin Result := False; Exit; End;
        End;
        Inc(FCursor);
    End;
lab7:
    { setmark p2, line 55 }
    I_p2 := FCursor;
    Result := True;
End;

Function TGerman2Stemmer.r_postlude : Boolean;
Var
    C : Integer;
    AmongVar : Integer;
    v_1 : Integer;
Label
    lab0,
    lab1;
Begin
    { repeat, line 59 }
lab0:
    While True Do
    Begin
        v_1 := FCursor;
        Repeat
            { (, line 59 }
            { [, line 61 }
            FBra := FCursor;
            { substring, line 61 }
            AmongVar := FindAmong(a_1, 6);
            If (AmongVar = 0) Then
            Begin
                goto lab1;
            End;
            { ], line 61 }
            FKet := FCursor;
            Case AmongVar Of
                0:
                Begin
                    goto lab1;
                End;
                1:
                Begin
                    { (, line 62 }
                    { <-, line 62 }
                    SliceFrom('y');
                End;
                2:
                Begin
                    { (, line 63 }
                    { <-, line 63 }
                    SliceFrom('u');
                End;
                3:
                Begin
                    { (, line 64 }
                    { <-, line 64 }
                    SliceFrom('a');
                End;
                4:
                Begin
                    { (, line 65 }
                    { <-, line 65 }
                    SliceFrom('o');
                End;
                5:
                Begin
                    { (, line 66 }
                    { <-, line 66 }
                    SliceFrom('u');
                End;
                6:
                Begin
                    { (, line 67 }
                    { next, line 67 }
                    If (FCursor >= FLimit) Then
                    Begin
                        goto lab1;
                    End;
                    Inc(FCursor);
                End;
            End;
            goto lab0;
        Until True;
lab1:
        FCursor := v_1;
        Break;
    End;
    Result := True;
End;

Function TGerman2Stemmer.r_R1 : Boolean;
Var
    C : Integer;
Begin
    If Not (I_p1 <= FCursor) Then
    Begin
        Begin Result := False; Exit; End;
    End;
    Result := True;
End;

Function TGerman2Stemmer.r_R2 : Boolean;
Var
    C : Integer;
Begin
    If Not (I_p2 <= FCursor) Then
    Begin
        Begin Result := False; Exit; End;
    End;
    Result := True;
End;

Function TGerman2Stemmer.r_standard_suffix : Boolean;
Var
    C : Integer;
    AmongVar : Integer;
    v_1 : Integer;
    v_2 : Integer;
    v_3 : Integer;
    v_4 : Integer;
    v_5 : Integer;
    v_6 : Integer;
    v_7 : Integer;
    v_8 : Integer;
    v_9 : Integer;
Label
    lab0,
    lab1,
    lab2,
    lab3,
    lab4,
    lab5,
    lab6,
    lab7,
    lab8,
    lab9;
Begin
    { (, line 77 }
    { do, line 78 }
    v_1 := FLimit - FCursor;
    Repeat
        { (, line 78 }
        { [, line 79 }
        FKet := FCursor;
        { substring, line 79 }
        AmongVar := FindAmongBk(a_2, 7);
        If (AmongVar = 0) Then
        Begin
            goto lab0;
        End;
        { ], line 79 }
        FBra := FCursor;
        { call R1, line 79 }
        If (Not r_R1) Then
        Begin
            goto lab0;
        End;
        Case AmongVar Of
            0:
            Begin
                goto lab0;
            End;
            1:
            Begin
                { (, line 81 }
                { delete, line 81 }
                SliceDel;
            End;
            2:
            Begin
                { (, line 84 }
                If (Not (InGroupingBk(g_s_ending, 98, 116))) Then
                Begin
                    goto lab0;
                End;
                { delete, line 84 }
                SliceDel;
            End;
        End;
    Until True;
lab0:
    FCursor := FLimit - v_1;
    { do, line 88 }
    v_2 := FLimit - FCursor;
    Repeat
        { (, line 88 }
        { [, line 89 }
        FKet := FCursor;
        { substring, line 89 }
        AmongVar := FindAmongBk(a_3, 4);
        If (AmongVar = 0) Then
        Begin
            goto lab1;
        End;
        { ], line 89 }
        FBra := FCursor;
        { call R1, line 89 }
        If (Not r_R1) Then
        Begin
            goto lab1;
        End;
        Case AmongVar Of
            0:
            Begin
                goto lab1;
            End;
            1:
            Begin
                { (, line 91 }
                { delete, line 91 }
                SliceDel;
            End;
            2:
            Begin
                { (, line 94 }
                If (Not (InGroupingBk(g_st_ending, 98, 116))) Then
                Begin
                    goto lab1;
                End;
                { hop, line 94 }
                Begin
                    C := FCursor - 3;
                    If ((FBkLimit > C) Or (C > FLimit)) Then
                    Begin
                        goto lab1;
                    End;
                    FCursor := c;
                End;
                { delete, line 94 }
                SliceDel;
            End;
        End;
    Until True;
lab1:
    FCursor := FLimit - v_2;
    { do, line 98 }
    v_3 := FLimit - FCursor;
    Repeat
        { (, line 98 }
        { [, line 99 }
        FKet := FCursor;
        { substring, line 99 }
        AmongVar := FindAmongBk(a_5, 8);
        If (AmongVar = 0) Then
        Begin
            goto lab2;
        End;
        { ], line 99 }
        FBra := FCursor;
        { call R2, line 99 }
        If (Not r_R2) Then
        Begin
            goto lab2;
        End;
        Case AmongVar Of
            0:
            Begin
                goto lab2;
            End;
            1:
            Begin
                { (, line 101 }
                { delete, line 101 }
                SliceDel;
                { try, line 102 }
                v_4 := FLimit - FCursor;
                Repeat
                    { (, line 102 }
                    { [, line 102 }
                    FKet := FCursor;
                    { literal, line 102 }
                    If (Not (EqSBk(2, 'ig'))) Then
                    Begin
                        FCursor := FLimit - v_4;
                        goto lab3;
                    End;
                    { ], line 102 }
                    FBra := FCursor;
                    { not, line 102 }
                    Begin
                        v_5 := FLimit - FCursor;
                        Repeat
                            { literal, line 102 }
                            If (Not (EqSBk(1, 'e'))) Then
                            Begin
                                goto lab4;
                            End;
                            FCursor := FLimit - v_4;
                            goto lab3;
                        Until True;
lab4:
                        FCursor := FLimit - v_5;
                    End;
                    { call R2, line 102 }
                    If (Not r_R2) Then
                    Begin
                        FCursor := FLimit - v_4;
                        goto lab3;
                    End;
                    { delete, line 102 }
                    SliceDel;
                Until True;
lab3:
            End;
            2:
            Begin
                { (, line 105 }
                { not, line 105 }
                Begin
                    v_6 := FLimit - FCursor;
                    Repeat
                        { literal, line 105 }
                        If (Not (EqSBk(1, 'e'))) Then
                        Begin
                            goto lab5;
                        End;
                        goto lab2;
                    Until True;
lab5:
                    FCursor := FLimit - v_6;
                End;
                { delete, line 105 }
                SliceDel;
            End;
            3:
            Begin
                { (, line 108 }
                { delete, line 108 }
                SliceDel;
                { try, line 109 }
                v_7 := FLimit - FCursor;
                Repeat
                    { (, line 109 }
                    { [, line 110 }
                    FKet := FCursor;
                    { or, line 110 }
                    Repeat
                        v_8 := FLimit - FCursor;
                        Repeat
                            { literal, line 110 }
                            If (Not (EqSBk(2, 'er'))) Then
                            Begin
                                goto lab8;
                            End;
                            goto lab7;
                        Until True;
lab8:
                        FCursor := FLimit - v_8;
                        { literal, line 110 }
                        If (Not (EqSBk(2, 'en'))) Then
                        Begin
                            FCursor := FLimit - v_7;
                            goto lab6;
                        End;
                    Until True;
lab7:
                    { ], line 110 }
                    FBra := FCursor;
                    { call R1, line 110 }
                    If (Not r_R1) Then
                    Begin
                        FCursor := FLimit - v_7;
                        goto lab6;
                    End;
                    { delete, line 110 }
                    SliceDel;
                Until True;
lab6:
            End;
            4:
            Begin
                { (, line 114 }
                { delete, line 114 }
                SliceDel;
                { try, line 115 }
                v_9 := FLimit - FCursor;
                Repeat
                    { (, line 115 }
                    { [, line 116 }
                    FKet := FCursor;
                    { substring, line 116 }
                    AmongVar := FindAmongBk(a_4, 2);
                    If (AmongVar = 0) Then
                    Begin
                        FCursor := FLimit - v_9;
                        goto lab9;
                    End;
                    { ], line 116 }
                    FBra := FCursor;
                    { call R2, line 116 }
                    If (Not r_R2) Then
                    Begin
                        FCursor := FLimit - v_9;
                        goto lab9;
                    End;
                    Case AmongVar Of
                        0:
                        Begin
                            FCursor := FLimit - v_9;
                            goto lab9;
                        End;
                        1:
                        Begin
                            { (, line 118 }
                            { delete, line 118 }
                            SliceDel;
                        End;
                    End;
                Until True;
lab9:
            End;
        End;
    Until True;
lab2:
    FCursor := FLimit - v_3;
    Result := True;
End;

Function TGerman2Stemmer.stem : Boolean;
Var
    C : Integer;
    v_1 : Integer;
    v_2 : Integer;
    v_3 : Integer;
    v_4 : Integer;
Label
    lab0,
    lab1,
    lab2,
    lab3;
Begin
    { (, line 128 }
    { do, line 129 }
    v_1 := FCursor;
    Repeat
        { call prelude, line 129 }
        If (Not r_prelude) Then
        Begin
            goto lab0;
        End;
    Until True;
lab0:
    FCursor := v_1;
    { do, line 130 }
    v_2 := FCursor;
    Repeat
        { call mark_regions, line 130 }
        If (Not r_mark_regions) Then
        Begin
            goto lab1;
        End;
    Until True;
lab1:
    FCursor := v_2;
    { backwards, line 131 }
    FBkLimit := FCursor; FCursor := FLimit;
    { do, line 132 }
    v_3 := FLimit - FCursor;
    Repeat
        { call standard_suffix, line 132 }
        If (Not r_standard_suffix) Then
        Begin
            goto lab2;
        End;
    Until True;
lab2:
    FCursor := FLimit - v_3;
    FCursor := FBkLimit;    { do, line 133 }
    v_4 := FCursor;
    Repeat
        { call postlude, line 133 }
        If (Not r_postlude) Then
        Begin
            goto lab3;
        End;
    Until True;
lab3:
    FCursor := v_4;
    Result := True;
End;

End.
