{ This file was generated automatically by the Snowball to Delphi compiler. }

Unit SpanishStemmer;

{$HINTS OFF}

Interface

Uses SnowballProgram;

Type
    TSpanishStemmer = Class(TSnowballProgram)
    private
        I_p2 : Integer;
        I_p1 : Integer;
        I_pV : Integer;
    private
        a_0 : Array Of TAmong;
        a_1 : Array Of TAmong;
        a_2 : Array Of TAmong;
        a_3 : Array Of TAmong;
        a_4 : Array Of TAmong;
        a_5 : Array Of TAmong;
        a_6 : Array Of TAmong;
        a_7 : Array Of TAmong;
        a_8 : Array Of TAmong;
        a_9 : Array Of TAmong;
    public
        Constructor Create;
        Function stem : Boolean;
    private
        Function r_mark_regions : Boolean;
        Function r_postlude : Boolean;
        Function r_RV : Boolean;
        Function r_R1 : Boolean;
        Function r_R2 : Boolean;
        Function r_attached_pronoun : Boolean;
        Function r_standard_suffix : Boolean;
        Function r_y_verb_suffix : Boolean;
        Function r_verb_suffix : Boolean;
        Function r_residual_suffix : Boolean;
End;

Implementation

Const
    g_v : Array [0..19] Of Char = (
        Chr(17),
        Chr(65),
        Chr(16),
        Chr(0),
        Chr(0),
        Chr(0),
        Chr(0),
        Chr(0),
        Chr(0),
        Chr(0),
        Chr(0),
        Chr(0),
        Chr(0),
        Chr(0),
        Chr(0),
        Chr(0),
        Chr(1),
        Chr(17),
        Chr(4),
        Chr(10)
    );

Constructor TSpanishStemmer.Create;
Begin
    SetLength(a_0, 6);
        a_0[0].Str  := '';
        a_0[0].Size := Length(a_0[0].Str);
        a_0[0].Index := -1;
        a_0[0].Result := 6;
        a_0[0].Method := nil;

        a_0[1].Str  := ''#225'';
        a_0[1].Size := Length(a_0[1].Str);
        a_0[1].Index := 0;
        a_0[1].Result := 1;
        a_0[1].Method := nil;

        a_0[2].Str  := ''#233'';
        a_0[2].Size := Length(a_0[2].Str);
        a_0[2].Index := 0;
        a_0[2].Result := 2;
        a_0[2].Method := nil;

        a_0[3].Str  := ''#237'';
        a_0[3].Size := Length(a_0[3].Str);
        a_0[3].Index := 0;
        a_0[3].Result := 3;
        a_0[3].Method := nil;

        a_0[4].Str  := ''#243'';
        a_0[4].Size := Length(a_0[4].Str);
        a_0[4].Index := 0;
        a_0[4].Result := 4;
        a_0[4].Method := nil;

        a_0[5].Str  := ''#250'';
        a_0[5].Size := Length(a_0[5].Str);
        a_0[5].Index := 0;
        a_0[5].Result := 5;
        a_0[5].Method := nil;

    SetLength(a_1, 13);
        a_1[0].Str  := 'la';
        a_1[0].Size := Length(a_1[0].Str);
        a_1[0].Index := -1;
        a_1[0].Result := -1;
        a_1[0].Method := nil;

        a_1[1].Str  := 'sela';
        a_1[1].Size := Length(a_1[1].Str);
        a_1[1].Index := 0;
        a_1[1].Result := -1;
        a_1[1].Method := nil;

        a_1[2].Str  := 'le';
        a_1[2].Size := Length(a_1[2].Str);
        a_1[2].Index := -1;
        a_1[2].Result := -1;
        a_1[2].Method := nil;

        a_1[3].Str  := 'me';
        a_1[3].Size := Length(a_1[3].Str);
        a_1[3].Index := -1;
        a_1[3].Result := -1;
        a_1[3].Method := nil;

        a_1[4].Str  := 'se';
        a_1[4].Size := Length(a_1[4].Str);
        a_1[4].Index := -1;
        a_1[4].Result := -1;
        a_1[4].Method := nil;

        a_1[5].Str  := 'lo';
        a_1[5].Size := Length(a_1[5].Str);
        a_1[5].Index := -1;
        a_1[5].Result := -1;
        a_1[5].Method := nil;

        a_1[6].Str  := 'selo';
        a_1[6].Size := Length(a_1[6].Str);
        a_1[6].Index := 5;
        a_1[6].Result := -1;
        a_1[6].Method := nil;

        a_1[7].Str  := 'las';
        a_1[7].Size := Length(a_1[7].Str);
        a_1[7].Index := -1;
        a_1[7].Result := -1;
        a_1[7].Method := nil;

        a_1[8].Str  := 'selas';
        a_1[8].Size := Length(a_1[8].Str);
        a_1[8].Index := 7;
        a_1[8].Result := -1;
        a_1[8].Method := nil;

        a_1[9].Str  := 'les';
        a_1[9].Size := Length(a_1[9].Str);
        a_1[9].Index := -1;
        a_1[9].Result := -1;
        a_1[9].Method := nil;

        a_1[10].Str  := 'los';
        a_1[10].Size := Length(a_1[10].Str);
        a_1[10].Index := -1;
        a_1[10].Result := -1;
        a_1[10].Method := nil;

        a_1[11].Str  := 'selos';
        a_1[11].Size := Length(a_1[11].Str);
        a_1[11].Index := 10;
        a_1[11].Result := -1;
        a_1[11].Method := nil;

        a_1[12].Str  := 'nos';
        a_1[12].Size := Length(a_1[12].Str);
        a_1[12].Index := -1;
        a_1[12].Result := -1;
        a_1[12].Method := nil;

    SetLength(a_2, 11);
        a_2[0].Str  := 'ando';
        a_2[0].Size := Length(a_2[0].Str);
        a_2[0].Index := -1;
        a_2[0].Result := 6;
        a_2[0].Method := nil;

        a_2[1].Str  := 'iendo';
        a_2[1].Size := Length(a_2[1].Str);
        a_2[1].Index := -1;
        a_2[1].Result := 6;
        a_2[1].Method := nil;

        a_2[2].Str  := 'yendo';
        a_2[2].Size := Length(a_2[2].Str);
        a_2[2].Index := -1;
        a_2[2].Result := 7;
        a_2[2].Method := nil;

        a_2[3].Str  := ''#225'ndo';
        a_2[3].Size := Length(a_2[3].Str);
        a_2[3].Index := -1;
        a_2[3].Result := 2;
        a_2[3].Method := nil;

        a_2[4].Str  := 'i'#233'ndo';
        a_2[4].Size := Length(a_2[4].Str);
        a_2[4].Index := -1;
        a_2[4].Result := 1;
        a_2[4].Method := nil;

        a_2[5].Str  := 'ar';
        a_2[5].Size := Length(a_2[5].Str);
        a_2[5].Index := -1;
        a_2[5].Result := 6;
        a_2[5].Method := nil;

        a_2[6].Str  := 'er';
        a_2[6].Size := Length(a_2[6].Str);
        a_2[6].Index := -1;
        a_2[6].Result := 6;
        a_2[6].Method := nil;

        a_2[7].Str  := 'ir';
        a_2[7].Size := Length(a_2[7].Str);
        a_2[7].Index := -1;
        a_2[7].Result := 6;
        a_2[7].Method := nil;

        a_2[8].Str  := ''#225'r';
        a_2[8].Size := Length(a_2[8].Str);
        a_2[8].Index := -1;
        a_2[8].Result := 3;
        a_2[8].Method := nil;

        a_2[9].Str  := ''#233'r';
        a_2[9].Size := Length(a_2[9].Str);
        a_2[9].Index := -1;
        a_2[9].Result := 4;
        a_2[9].Method := nil;

        a_2[10].Str  := ''#237'r';
        a_2[10].Size := Length(a_2[10].Str);
        a_2[10].Index := -1;
        a_2[10].Result := 5;
        a_2[10].Method := nil;

    SetLength(a_3, 4);
        a_3[0].Str  := 'ic';
        a_3[0].Size := Length(a_3[0].Str);
        a_3[0].Index := -1;
        a_3[0].Result := -1;
        a_3[0].Method := nil;

        a_3[1].Str  := 'ad';
        a_3[1].Size := Length(a_3[1].Str);
        a_3[1].Index := -1;
        a_3[1].Result := -1;
        a_3[1].Method := nil;

        a_3[2].Str  := 'os';
        a_3[2].Size := Length(a_3[2].Str);
        a_3[2].Index := -1;
        a_3[2].Result := -1;
        a_3[2].Method := nil;

        a_3[3].Str  := 'iv';
        a_3[3].Size := Length(a_3[3].Str);
        a_3[3].Index := -1;
        a_3[3].Result := 1;
        a_3[3].Method := nil;

    SetLength(a_4, 2);
        a_4[0].Str  := 'able';
        a_4[0].Size := Length(a_4[0].Str);
        a_4[0].Index := -1;
        a_4[0].Result := 1;
        a_4[0].Method := nil;

        a_4[1].Str  := 'ible';
        a_4[1].Size := Length(a_4[1].Str);
        a_4[1].Index := -1;
        a_4[1].Result := 1;
        a_4[1].Method := nil;

    SetLength(a_5, 3);
        a_5[0].Str  := 'ic';
        a_5[0].Size := Length(a_5[0].Str);
        a_5[0].Index := -1;
        a_5[0].Result := 1;
        a_5[0].Method := nil;

        a_5[1].Str  := 'abil';
        a_5[1].Size := Length(a_5[1].Str);
        a_5[1].Index := -1;
        a_5[1].Result := 1;
        a_5[1].Method := nil;

        a_5[2].Str  := 'iv';
        a_5[2].Size := Length(a_5[2].Str);
        a_5[2].Index := -1;
        a_5[2].Result := 1;
        a_5[2].Method := nil;

    SetLength(a_6, 42);
        a_6[0].Str  := 'ica';
        a_6[0].Size := Length(a_6[0].Str);
        a_6[0].Index := -1;
        a_6[0].Result := 1;
        a_6[0].Method := nil;

        a_6[1].Str  := 'encia';
        a_6[1].Size := Length(a_6[1].Str);
        a_6[1].Index := -1;
        a_6[1].Result := 5;
        a_6[1].Method := nil;

        a_6[2].Str  := 'adora';
        a_6[2].Size := Length(a_6[2].Str);
        a_6[2].Index := -1;
        a_6[2].Result := 2;
        a_6[2].Method := nil;

        a_6[3].Str  := 'osa';
        a_6[3].Size := Length(a_6[3].Str);
        a_6[3].Index := -1;
        a_6[3].Result := 1;
        a_6[3].Method := nil;

        a_6[4].Str  := 'ista';
        a_6[4].Size := Length(a_6[4].Str);
        a_6[4].Index := -1;
        a_6[4].Result := 1;
        a_6[4].Method := nil;

        a_6[5].Str  := 'iva';
        a_6[5].Size := Length(a_6[5].Str);
        a_6[5].Index := -1;
        a_6[5].Result := 9;
        a_6[5].Method := nil;

        a_6[6].Str  := 'anza';
        a_6[6].Size := Length(a_6[6].Str);
        a_6[6].Index := -1;
        a_6[6].Result := 1;
        a_6[6].Method := nil;

        a_6[7].Str  := 'log'#237'a';
        a_6[7].Size := Length(a_6[7].Str);
        a_6[7].Index := -1;
        a_6[7].Result := 3;
        a_6[7].Method := nil;

        a_6[8].Str  := 'idad';
        a_6[8].Size := Length(a_6[8].Str);
        a_6[8].Index := -1;
        a_6[8].Result := 8;
        a_6[8].Method := nil;

        a_6[9].Str  := 'able';
        a_6[9].Size := Length(a_6[9].Str);
        a_6[9].Index := -1;
        a_6[9].Result := 1;
        a_6[9].Method := nil;

        a_6[10].Str  := 'ible';
        a_6[10].Size := Length(a_6[10].Str);
        a_6[10].Index := -1;
        a_6[10].Result := 1;
        a_6[10].Method := nil;

        a_6[11].Str  := 'mente';
        a_6[11].Size := Length(a_6[11].Str);
        a_6[11].Index := -1;
        a_6[11].Result := 7;
        a_6[11].Method := nil;

        a_6[12].Str  := 'amente';
        a_6[12].Size := Length(a_6[12].Str);
        a_6[12].Index := 11;
        a_6[12].Result := 6;
        a_6[12].Method := nil;

        a_6[13].Str  := 'aci'#243'n';
        a_6[13].Size := Length(a_6[13].Str);
        a_6[13].Index := -1;
        a_6[13].Result := 2;
        a_6[13].Method := nil;

        a_6[14].Str  := 'uci'#243'n';
        a_6[14].Size := Length(a_6[14].Str);
        a_6[14].Index := -1;
        a_6[14].Result := 4;
        a_6[14].Method := nil;

        a_6[15].Str  := 'ico';
        a_6[15].Size := Length(a_6[15].Str);
        a_6[15].Index := -1;
        a_6[15].Result := 1;
        a_6[15].Method := nil;

        a_6[16].Str  := 'ismo';
        a_6[16].Size := Length(a_6[16].Str);
        a_6[16].Index := -1;
        a_6[16].Result := 1;
        a_6[16].Method := nil;

        a_6[17].Str  := 'oso';
        a_6[17].Size := Length(a_6[17].Str);
        a_6[17].Index := -1;
        a_6[17].Result := 1;
        a_6[17].Method := nil;

        a_6[18].Str  := 'amiento';
        a_6[18].Size := Length(a_6[18].Str);
        a_6[18].Index := -1;
        a_6[18].Result := 1;
        a_6[18].Method := nil;

        a_6[19].Str  := 'imiento';
        a_6[19].Size := Length(a_6[19].Str);
        a_6[19].Index := -1;
        a_6[19].Result := 1;
        a_6[19].Method := nil;

        a_6[20].Str  := 'ivo';
        a_6[20].Size := Length(a_6[20].Str);
        a_6[20].Index := -1;
        a_6[20].Result := 9;
        a_6[20].Method := nil;

        a_6[21].Str  := 'ador';
        a_6[21].Size := Length(a_6[21].Str);
        a_6[21].Index := -1;
        a_6[21].Result := 2;
        a_6[21].Method := nil;

        a_6[22].Str  := 'icas';
        a_6[22].Size := Length(a_6[22].Str);
        a_6[22].Index := -1;
        a_6[22].Result := 1;
        a_6[22].Method := nil;

        a_6[23].Str  := 'encias';
        a_6[23].Size := Length(a_6[23].Str);
        a_6[23].Index := -1;
        a_6[23].Result := 5;
        a_6[23].Method := nil;

        a_6[24].Str  := 'adoras';
        a_6[24].Size := Length(a_6[24].Str);
        a_6[24].Index := -1;
        a_6[24].Result := 2;
        a_6[24].Method := nil;

        a_6[25].Str  := 'osas';
        a_6[25].Size := Length(a_6[25].Str);
        a_6[25].Index := -1;
        a_6[25].Result := 1;
        a_6[25].Method := nil;

        a_6[26].Str  := 'istas';
        a_6[26].Size := Length(a_6[26].Str);
        a_6[26].Index := -1;
        a_6[26].Result := 1;
        a_6[26].Method := nil;

        a_6[27].Str  := 'ivas';
        a_6[27].Size := Length(a_6[27].Str);
        a_6[27].Index := -1;
        a_6[27].Result := 9;
        a_6[27].Method := nil;

        a_6[28].Str  := 'anzas';
        a_6[28].Size := Length(a_6[28].Str);
        a_6[28].Index := -1;
        a_6[28].Result := 1;
        a_6[28].Method := nil;

        a_6[29].Str  := 'log'#237'as';
        a_6[29].Size := Length(a_6[29].Str);
        a_6[29].Index := -1;
        a_6[29].Result := 3;
        a_6[29].Method := nil;

        a_6[30].Str  := 'idades';
        a_6[30].Size := Length(a_6[30].Str);
        a_6[30].Index := -1;
        a_6[30].Result := 8;
        a_6[30].Method := nil;

        a_6[31].Str  := 'ables';
        a_6[31].Size := Length(a_6[31].Str);
        a_6[31].Index := -1;
        a_6[31].Result := 1;
        a_6[31].Method := nil;

        a_6[32].Str  := 'ibles';
        a_6[32].Size := Length(a_6[32].Str);
        a_6[32].Index := -1;
        a_6[32].Result := 1;
        a_6[32].Method := nil;

        a_6[33].Str  := 'aciones';
        a_6[33].Size := Length(a_6[33].Str);
        a_6[33].Index := -1;
        a_6[33].Result := 2;
        a_6[33].Method := nil;

        a_6[34].Str  := 'uciones';
        a_6[34].Size := Length(a_6[34].Str);
        a_6[34].Index := -1;
        a_6[34].Result := 4;
        a_6[34].Method := nil;

        a_6[35].Str  := 'adores';
        a_6[35].Size := Length(a_6[35].Str);
        a_6[35].Index := -1;
        a_6[35].Result := 2;
        a_6[35].Method := nil;

        a_6[36].Str  := 'icos';
        a_6[36].Size := Length(a_6[36].Str);
        a_6[36].Index := -1;
        a_6[36].Result := 1;
        a_6[36].Method := nil;

        a_6[37].Str  := 'ismos';
        a_6[37].Size := Length(a_6[37].Str);
        a_6[37].Index := -1;
        a_6[37].Result := 1;
        a_6[37].Method := nil;

        a_6[38].Str  := 'osos';
        a_6[38].Size := Length(a_6[38].Str);
        a_6[38].Index := -1;
        a_6[38].Result := 1;
        a_6[38].Method := nil;

        a_6[39].Str  := 'amientos';
        a_6[39].Size := Length(a_6[39].Str);
        a_6[39].Index := -1;
        a_6[39].Result := 1;
        a_6[39].Method := nil;

        a_6[40].Str  := 'imientos';
        a_6[40].Size := Length(a_6[40].Str);
        a_6[40].Index := -1;
        a_6[40].Result := 1;
        a_6[40].Method := nil;

        a_6[41].Str  := 'ivos';
        a_6[41].Size := Length(a_6[41].Str);
        a_6[41].Index := -1;
        a_6[41].Result := 9;
        a_6[41].Method := nil;

    SetLength(a_7, 12);
        a_7[0].Str  := 'ya';
        a_7[0].Size := Length(a_7[0].Str);
        a_7[0].Index := -1;
        a_7[0].Result := 1;
        a_7[0].Method := nil;

        a_7[1].Str  := 'ye';
        a_7[1].Size := Length(a_7[1].Str);
        a_7[1].Index := -1;
        a_7[1].Result := 1;
        a_7[1].Method := nil;

        a_7[2].Str  := 'yan';
        a_7[2].Size := Length(a_7[2].Str);
        a_7[2].Index := -1;
        a_7[2].Result := 1;
        a_7[2].Method := nil;

        a_7[3].Str  := 'yen';
        a_7[3].Size := Length(a_7[3].Str);
        a_7[3].Index := -1;
        a_7[3].Result := 1;
        a_7[3].Method := nil;

        a_7[4].Str  := 'yeron';
        a_7[4].Size := Length(a_7[4].Str);
        a_7[4].Index := -1;
        a_7[4].Result := 1;
        a_7[4].Method := nil;

        a_7[5].Str  := 'yendo';
        a_7[5].Size := Length(a_7[5].Str);
        a_7[5].Index := -1;
        a_7[5].Result := 1;
        a_7[5].Method := nil;

        a_7[6].Str  := 'yo';
        a_7[6].Size := Length(a_7[6].Str);
        a_7[6].Index := -1;
        a_7[6].Result := 1;
        a_7[6].Method := nil;

        a_7[7].Str  := 'yas';
        a_7[7].Size := Length(a_7[7].Str);
        a_7[7].Index := -1;
        a_7[7].Result := 1;
        a_7[7].Method := nil;

        a_7[8].Str  := 'yes';
        a_7[8].Size := Length(a_7[8].Str);
        a_7[8].Index := -1;
        a_7[8].Result := 1;
        a_7[8].Method := nil;

        a_7[9].Str  := 'yais';
        a_7[9].Size := Length(a_7[9].Str);
        a_7[9].Index := -1;
        a_7[9].Result := 1;
        a_7[9].Method := nil;

        a_7[10].Str  := 'yamos';
        a_7[10].Size := Length(a_7[10].Str);
        a_7[10].Index := -1;
        a_7[10].Result := 1;
        a_7[10].Method := nil;

        a_7[11].Str  := 'y'#243'';
        a_7[11].Size := Length(a_7[11].Str);
        a_7[11].Index := -1;
        a_7[11].Result := 1;
        a_7[11].Method := nil;

    SetLength(a_8, 96);
        a_8[0].Str  := 'aba';
        a_8[0].Size := Length(a_8[0].Str);
        a_8[0].Index := -1;
        a_8[0].Result := 2;
        a_8[0].Method := nil;

        a_8[1].Str  := 'ada';
        a_8[1].Size := Length(a_8[1].Str);
        a_8[1].Index := -1;
        a_8[1].Result := 2;
        a_8[1].Method := nil;

        a_8[2].Str  := 'ida';
        a_8[2].Size := Length(a_8[2].Str);
        a_8[2].Index := -1;
        a_8[2].Result := 2;
        a_8[2].Method := nil;

        a_8[3].Str  := 'ara';
        a_8[3].Size := Length(a_8[3].Str);
        a_8[3].Index := -1;
        a_8[3].Result := 2;
        a_8[3].Method := nil;

        a_8[4].Str  := 'iera';
        a_8[4].Size := Length(a_8[4].Str);
        a_8[4].Index := -1;
        a_8[4].Result := 2;
        a_8[4].Method := nil;

        a_8[5].Str  := ''#237'a';
        a_8[5].Size := Length(a_8[5].Str);
        a_8[5].Index := -1;
        a_8[5].Result := 2;
        a_8[5].Method := nil;

        a_8[6].Str  := 'ar'#237'a';
        a_8[6].Size := Length(a_8[6].Str);
        a_8[6].Index := 5;
        a_8[6].Result := 2;
        a_8[6].Method := nil;

        a_8[7].Str  := 'er'#237'a';
        a_8[7].Size := Length(a_8[7].Str);
        a_8[7].Index := 5;
        a_8[7].Result := 2;
        a_8[7].Method := nil;

        a_8[8].Str  := 'ir'#237'a';
        a_8[8].Size := Length(a_8[8].Str);
        a_8[8].Index := 5;
        a_8[8].Result := 2;
        a_8[8].Method := nil;

        a_8[9].Str  := 'ad';
        a_8[9].Size := Length(a_8[9].Str);
        a_8[9].Index := -1;
        a_8[9].Result := 2;
        a_8[9].Method := nil;

        a_8[10].Str  := 'ed';
        a_8[10].Size := Length(a_8[10].Str);
        a_8[10].Index := -1;
        a_8[10].Result := 2;
        a_8[10].Method := nil;

        a_8[11].Str  := 'id';
        a_8[11].Size := Length(a_8[11].Str);
        a_8[11].Index := -1;
        a_8[11].Result := 2;
        a_8[11].Method := nil;

        a_8[12].Str  := 'ase';
        a_8[12].Size := Length(a_8[12].Str);
        a_8[12].Index := -1;
        a_8[12].Result := 2;
        a_8[12].Method := nil;

        a_8[13].Str  := 'iese';
        a_8[13].Size := Length(a_8[13].Str);
        a_8[13].Index := -1;
        a_8[13].Result := 2;
        a_8[13].Method := nil;

        a_8[14].Str  := 'aste';
        a_8[14].Size := Length(a_8[14].Str);
        a_8[14].Index := -1;
        a_8[14].Result := 2;
        a_8[14].Method := nil;

        a_8[15].Str  := 'iste';
        a_8[15].Size := Length(a_8[15].Str);
        a_8[15].Index := -1;
        a_8[15].Result := 2;
        a_8[15].Method := nil;

        a_8[16].Str  := 'an';
        a_8[16].Size := Length(a_8[16].Str);
        a_8[16].Index := -1;
        a_8[16].Result := 2;
        a_8[16].Method := nil;

        a_8[17].Str  := 'aban';
        a_8[17].Size := Length(a_8[17].Str);
        a_8[17].Index := 16;
        a_8[17].Result := 2;
        a_8[17].Method := nil;

        a_8[18].Str  := 'aran';
        a_8[18].Size := Length(a_8[18].Str);
        a_8[18].Index := 16;
        a_8[18].Result := 2;
        a_8[18].Method := nil;

        a_8[19].Str  := 'ieran';
        a_8[19].Size := Length(a_8[19].Str);
        a_8[19].Index := 16;
        a_8[19].Result := 2;
        a_8[19].Method := nil;

        a_8[20].Str  := ''#237'an';
        a_8[20].Size := Length(a_8[20].Str);
        a_8[20].Index := 16;
        a_8[20].Result := 2;
        a_8[20].Method := nil;

        a_8[21].Str  := 'ar'#237'an';
        a_8[21].Size := Length(a_8[21].Str);
        a_8[21].Index := 20;
        a_8[21].Result := 2;
        a_8[21].Method := nil;

        a_8[22].Str  := 'er'#237'an';
        a_8[22].Size := Length(a_8[22].Str);
        a_8[22].Index := 20;
        a_8[22].Result := 2;
        a_8[22].Method := nil;

        a_8[23].Str  := 'ir'#237'an';
        a_8[23].Size := Length(a_8[23].Str);
        a_8[23].Index := 20;
        a_8[23].Result := 2;
        a_8[23].Method := nil;

        a_8[24].Str  := 'en';
        a_8[24].Size := Length(a_8[24].Str);
        a_8[24].Index := -1;
        a_8[24].Result := 1;
        a_8[24].Method := nil;

        a_8[25].Str  := 'asen';
        a_8[25].Size := Length(a_8[25].Str);
        a_8[25].Index := 24;
        a_8[25].Result := 2;
        a_8[25].Method := nil;

        a_8[26].Str  := 'iesen';
        a_8[26].Size := Length(a_8[26].Str);
        a_8[26].Index := 24;
        a_8[26].Result := 2;
        a_8[26].Method := nil;

        a_8[27].Str  := 'aron';
        a_8[27].Size := Length(a_8[27].Str);
        a_8[27].Index := -1;
        a_8[27].Result := 2;
        a_8[27].Method := nil;

        a_8[28].Str  := 'ieron';
        a_8[28].Size := Length(a_8[28].Str);
        a_8[28].Index := -1;
        a_8[28].Result := 2;
        a_8[28].Method := nil;

        a_8[29].Str  := 'ar'#225'n';
        a_8[29].Size := Length(a_8[29].Str);
        a_8[29].Index := -1;
        a_8[29].Result := 2;
        a_8[29].Method := nil;

        a_8[30].Str  := 'er'#225'n';
        a_8[30].Size := Length(a_8[30].Str);
        a_8[30].Index := -1;
        a_8[30].Result := 2;
        a_8[30].Method := nil;

        a_8[31].Str  := 'ir'#225'n';
        a_8[31].Size := Length(a_8[31].Str);
        a_8[31].Index := -1;
        a_8[31].Result := 2;
        a_8[31].Method := nil;

        a_8[32].Str  := 'ado';
        a_8[32].Size := Length(a_8[32].Str);
        a_8[32].Index := -1;
        a_8[32].Result := 2;
        a_8[32].Method := nil;

        a_8[33].Str  := 'ido';
        a_8[33].Size := Length(a_8[33].Str);
        a_8[33].Index := -1;
        a_8[33].Result := 2;
        a_8[33].Method := nil;

        a_8[34].Str  := 'ando';
        a_8[34].Size := Length(a_8[34].Str);
        a_8[34].Index := -1;
        a_8[34].Result := 2;
        a_8[34].Method := nil;

        a_8[35].Str  := 'iendo';
        a_8[35].Size := Length(a_8[35].Str);
        a_8[35].Index := -1;
        a_8[35].Result := 2;
        a_8[35].Method := nil;

        a_8[36].Str  := 'ar';
        a_8[36].Size := Length(a_8[36].Str);
        a_8[36].Index := -1;
        a_8[36].Result := 2;
        a_8[36].Method := nil;

        a_8[37].Str  := 'er';
        a_8[37].Size := Length(a_8[37].Str);
        a_8[37].Index := -1;
        a_8[37].Result := 2;
        a_8[37].Method := nil;

        a_8[38].Str  := 'ir';
        a_8[38].Size := Length(a_8[38].Str);
        a_8[38].Index := -1;
        a_8[38].Result := 2;
        a_8[38].Method := nil;

        a_8[39].Str  := 'as';
        a_8[39].Size := Length(a_8[39].Str);
        a_8[39].Index := -1;
        a_8[39].Result := 2;
        a_8[39].Method := nil;

        a_8[40].Str  := 'abas';
        a_8[40].Size := Length(a_8[40].Str);
        a_8[40].Index := 39;
        a_8[40].Result := 2;
        a_8[40].Method := nil;

        a_8[41].Str  := 'adas';
        a_8[41].Size := Length(a_8[41].Str);
        a_8[41].Index := 39;
        a_8[41].Result := 2;
        a_8[41].Method := nil;

        a_8[42].Str  := 'idas';
        a_8[42].Size := Length(a_8[42].Str);
        a_8[42].Index := 39;
        a_8[42].Result := 2;
        a_8[42].Method := nil;

        a_8[43].Str  := 'aras';
        a_8[43].Size := Length(a_8[43].Str);
        a_8[43].Index := 39;
        a_8[43].Result := 2;
        a_8[43].Method := nil;

        a_8[44].Str  := 'ieras';
        a_8[44].Size := Length(a_8[44].Str);
        a_8[44].Index := 39;
        a_8[44].Result := 2;
        a_8[44].Method := nil;

        a_8[45].Str  := ''#237'as';
        a_8[45].Size := Length(a_8[45].Str);
        a_8[45].Index := 39;
        a_8[45].Result := 2;
        a_8[45].Method := nil;

        a_8[46].Str  := 'ar'#237'as';
        a_8[46].Size := Length(a_8[46].Str);
        a_8[46].Index := 45;
        a_8[46].Result := 2;
        a_8[46].Method := nil;

        a_8[47].Str  := 'er'#237'as';
        a_8[47].Size := Length(a_8[47].Str);
        a_8[47].Index := 45;
        a_8[47].Result := 2;
        a_8[47].Method := nil;

        a_8[48].Str  := 'ir'#237'as';
        a_8[48].Size := Length(a_8[48].Str);
        a_8[48].Index := 45;
        a_8[48].Result := 2;
        a_8[48].Method := nil;

        a_8[49].Str  := 'es';
        a_8[49].Size := Length(a_8[49].Str);
        a_8[49].Index := -1;
        a_8[49].Result := 1;
        a_8[49].Method := nil;

        a_8[50].Str  := 'ases';
        a_8[50].Size := Length(a_8[50].Str);
        a_8[50].Index := 49;
        a_8[50].Result := 2;
        a_8[50].Method := nil;

        a_8[51].Str  := 'ieses';
        a_8[51].Size := Length(a_8[51].Str);
        a_8[51].Index := 49;
        a_8[51].Result := 2;
        a_8[51].Method := nil;

        a_8[52].Str  := 'abais';
        a_8[52].Size := Length(a_8[52].Str);
        a_8[52].Index := -1;
        a_8[52].Result := 2;
        a_8[52].Method := nil;

        a_8[53].Str  := 'arais';
        a_8[53].Size := Length(a_8[53].Str);
        a_8[53].Index := -1;
        a_8[53].Result := 2;
        a_8[53].Method := nil;

        a_8[54].Str  := 'ierais';
        a_8[54].Size := Length(a_8[54].Str);
        a_8[54].Index := -1;
        a_8[54].Result := 2;
        a_8[54].Method := nil;

        a_8[55].Str  := ''#237'ais';
        a_8[55].Size := Length(a_8[55].Str);
        a_8[55].Index := -1;
        a_8[55].Result := 2;
        a_8[55].Method := nil;

        a_8[56].Str  := 'ar'#237'ais';
        a_8[56].Size := Length(a_8[56].Str);
        a_8[56].Index := 55;
        a_8[56].Result := 2;
        a_8[56].Method := nil;

        a_8[57].Str  := 'er'#237'ais';
        a_8[57].Size := Length(a_8[57].Str);
        a_8[57].Index := 55;
        a_8[57].Result := 2;
        a_8[57].Method := nil;

        a_8[58].Str  := 'ir'#237'ais';
        a_8[58].Size := Length(a_8[58].Str);
        a_8[58].Index := 55;
        a_8[58].Result := 2;
        a_8[58].Method := nil;

        a_8[59].Str  := 'aseis';
        a_8[59].Size := Length(a_8[59].Str);
        a_8[59].Index := -1;
        a_8[59].Result := 2;
        a_8[59].Method := nil;

        a_8[60].Str  := 'ieseis';
        a_8[60].Size := Length(a_8[60].Str);
        a_8[60].Index := -1;
        a_8[60].Result := 2;
        a_8[60].Method := nil;

        a_8[61].Str  := 'asteis';
        a_8[61].Size := Length(a_8[61].Str);
        a_8[61].Index := -1;
        a_8[61].Result := 2;
        a_8[61].Method := nil;

        a_8[62].Str  := 'isteis';
        a_8[62].Size := Length(a_8[62].Str);
        a_8[62].Index := -1;
        a_8[62].Result := 2;
        a_8[62].Method := nil;

        a_8[63].Str  := ''#225'is';
        a_8[63].Size := Length(a_8[63].Str);
        a_8[63].Index := -1;
        a_8[63].Result := 2;
        a_8[63].Method := nil;

        a_8[64].Str  := ''#233'is';
        a_8[64].Size := Length(a_8[64].Str);
        a_8[64].Index := -1;
        a_8[64].Result := 1;
        a_8[64].Method := nil;

        a_8[65].Str  := 'ar'#233'is';
        a_8[65].Size := Length(a_8[65].Str);
        a_8[65].Index := 64;
        a_8[65].Result := 2;
        a_8[65].Method := nil;

        a_8[66].Str  := 'er'#233'is';
        a_8[66].Size := Length(a_8[66].Str);
        a_8[66].Index := 64;
        a_8[66].Result := 2;
        a_8[66].Method := nil;

        a_8[67].Str  := 'ir'#233'is';
        a_8[67].Size := Length(a_8[67].Str);
        a_8[67].Index := 64;
        a_8[67].Result := 2;
        a_8[67].Method := nil;

        a_8[68].Str  := 'ados';
        a_8[68].Size := Length(a_8[68].Str);
        a_8[68].Index := -1;
        a_8[68].Result := 2;
        a_8[68].Method := nil;

        a_8[69].Str  := 'idos';
        a_8[69].Size := Length(a_8[69].Str);
        a_8[69].Index := -1;
        a_8[69].Result := 2;
        a_8[69].Method := nil;

        a_8[70].Str  := 'amos';
        a_8[70].Size := Length(a_8[70].Str);
        a_8[70].Index := -1;
        a_8[70].Result := 2;
        a_8[70].Method := nil;

        a_8[71].Str  := ''#225'bamos';
        a_8[71].Size := Length(a_8[71].Str);
        a_8[71].Index := 70;
        a_8[71].Result := 2;
        a_8[71].Method := nil;

        a_8[72].Str  := ''#225'ramos';
        a_8[72].Size := Length(a_8[72].Str);
        a_8[72].Index := 70;
        a_8[72].Result := 2;
        a_8[72].Method := nil;

        a_8[73].Str  := 'i'#233'ramos';
        a_8[73].Size := Length(a_8[73].Str);
        a_8[73].Index := 70;
        a_8[73].Result := 2;
        a_8[73].Method := nil;

        a_8[74].Str  := ''#237'amos';
        a_8[74].Size := Length(a_8[74].Str);
        a_8[74].Index := 70;
        a_8[74].Result := 2;
        a_8[74].Method := nil;

        a_8[75].Str  := 'ar'#237'amos';
        a_8[75].Size := Length(a_8[75].Str);
        a_8[75].Index := 74;
        a_8[75].Result := 2;
        a_8[75].Method := nil;

        a_8[76].Str  := 'er'#237'amos';
        a_8[76].Size := Length(a_8[76].Str);
        a_8[76].Index := 74;
        a_8[76].Result := 2;
        a_8[76].Method := nil;

        a_8[77].Str  := 'ir'#237'amos';
        a_8[77].Size := Length(a_8[77].Str);
        a_8[77].Index := 74;
        a_8[77].Result := 2;
        a_8[77].Method := nil;

        a_8[78].Str  := 'emos';
        a_8[78].Size := Length(a_8[78].Str);
        a_8[78].Index := -1;
        a_8[78].Result := 1;
        a_8[78].Method := nil;

        a_8[79].Str  := 'aremos';
        a_8[79].Size := Length(a_8[79].Str);
        a_8[79].Index := 78;
        a_8[79].Result := 2;
        a_8[79].Method := nil;

        a_8[80].Str  := 'eremos';
        a_8[80].Size := Length(a_8[80].Str);
        a_8[80].Index := 78;
        a_8[80].Result := 2;
        a_8[80].Method := nil;

        a_8[81].Str  := 'iremos';
        a_8[81].Size := Length(a_8[81].Str);
        a_8[81].Index := 78;
        a_8[81].Result := 2;
        a_8[81].Method := nil;

        a_8[82].Str  := ''#225'semos';
        a_8[82].Size := Length(a_8[82].Str);
        a_8[82].Index := 78;
        a_8[82].Result := 2;
        a_8[82].Method := nil;

        a_8[83].Str  := 'i'#233'semos';
        a_8[83].Size := Length(a_8[83].Str);
        a_8[83].Index := 78;
        a_8[83].Result := 2;
        a_8[83].Method := nil;

        a_8[84].Str  := 'imos';
        a_8[84].Size := Length(a_8[84].Str);
        a_8[84].Index := -1;
        a_8[84].Result := 2;
        a_8[84].Method := nil;

        a_8[85].Str  := 'ar'#225's';
        a_8[85].Size := Length(a_8[85].Str);
        a_8[85].Index := -1;
        a_8[85].Result := 2;
        a_8[85].Method := nil;

        a_8[86].Str  := 'er'#225's';
        a_8[86].Size := Length(a_8[86].Str);
        a_8[86].Index := -1;
        a_8[86].Result := 2;
        a_8[86].Method := nil;

        a_8[87].Str  := 'ir'#225's';
        a_8[87].Size := Length(a_8[87].Str);
        a_8[87].Index := -1;
        a_8[87].Result := 2;
        a_8[87].Method := nil;

        a_8[88].Str  := ''#237's';
        a_8[88].Size := Length(a_8[88].Str);
        a_8[88].Index := -1;
        a_8[88].Result := 2;
        a_8[88].Method := nil;

        a_8[89].Str  := 'ar'#225'';
        a_8[89].Size := Length(a_8[89].Str);
        a_8[89].Index := -1;
        a_8[89].Result := 2;
        a_8[89].Method := nil;

        a_8[90].Str  := 'er'#225'';
        a_8[90].Size := Length(a_8[90].Str);
        a_8[90].Index := -1;
        a_8[90].Result := 2;
        a_8[90].Method := nil;

        a_8[91].Str  := 'ir'#225'';
        a_8[91].Size := Length(a_8[91].Str);
        a_8[91].Index := -1;
        a_8[91].Result := 2;
        a_8[91].Method := nil;

        a_8[92].Str  := 'ar'#233'';
        a_8[92].Size := Length(a_8[92].Str);
        a_8[92].Index := -1;
        a_8[92].Result := 2;
        a_8[92].Method := nil;

        a_8[93].Str  := 'er'#233'';
        a_8[93].Size := Length(a_8[93].Str);
        a_8[93].Index := -1;
        a_8[93].Result := 2;
        a_8[93].Method := nil;

        a_8[94].Str  := 'ir'#233'';
        a_8[94].Size := Length(a_8[94].Str);
        a_8[94].Index := -1;
        a_8[94].Result := 2;
        a_8[94].Method := nil;

        a_8[95].Str  := 'i'#243'';
        a_8[95].Size := Length(a_8[95].Str);
        a_8[95].Index := -1;
        a_8[95].Result := 2;
        a_8[95].Method := nil;

    SetLength(a_9, 8);
        a_9[0].Str  := 'a';
        a_9[0].Size := Length(a_9[0].Str);
        a_9[0].Index := -1;
        a_9[0].Result := 1;
        a_9[0].Method := nil;

        a_9[1].Str  := 'e';
        a_9[1].Size := Length(a_9[1].Str);
        a_9[1].Index := -1;
        a_9[1].Result := 2;
        a_9[1].Method := nil;

        a_9[2].Str  := 'o';
        a_9[2].Size := Length(a_9[2].Str);
        a_9[2].Index := -1;
        a_9[2].Result := 1;
        a_9[2].Method := nil;

        a_9[3].Str  := 'os';
        a_9[3].Size := Length(a_9[3].Str);
        a_9[3].Index := -1;
        a_9[3].Result := 1;
        a_9[3].Method := nil;

        a_9[4].Str  := ''#225'';
        a_9[4].Size := Length(a_9[4].Str);
        a_9[4].Index := -1;
        a_9[4].Result := 1;
        a_9[4].Method := nil;

        a_9[5].Str  := ''#233'';
        a_9[5].Size := Length(a_9[5].Str);
        a_9[5].Index := -1;
        a_9[5].Result := 2;
        a_9[5].Method := nil;

        a_9[6].Str  := ''#237'';
        a_9[6].Size := Length(a_9[6].Str);
        a_9[6].Index := -1;
        a_9[6].Result := 1;
        a_9[6].Method := nil;

        a_9[7].Str  := ''#243'';
        a_9[7].Size := Length(a_9[7].Str);
        a_9[7].Index := -1;
        a_9[7].Result := 1;
        a_9[7].Method := nil;

End;

Function TSpanishStemmer.r_mark_regions : Boolean;
Var
    C : Integer;
    v_1 : Integer;
    v_2 : Integer;
    v_3 : Integer;
    v_6 : Integer;
    v_8 : Integer;
Label
    lab0,
    lab1,
    lab2,
    lab3,
    lab4,
    lab5,
    lab6,
    lab7,
    lab8,
    lab9,
    lab10,
    lab11,
    lab12,
    lab13,
    lab14,
    lab15,
    lab16,
    lab17,
    lab18,
    lab19,
    lab20,
    lab21;
Begin
    { (, line 31 }
    I_pV := FLimit;
    I_p1 := FLimit;
    I_p2 := FLimit;
    { do, line 37 }
    v_1 := FCursor;
    Repeat
        { (, line 37 }
        { or, line 39 }
        Repeat
            v_2 := FCursor;
            Repeat
                { (, line 38 }
                If (Not (InGrouping(g_v, 97, 252))) Then
                Begin
                    goto lab2;
                End;
                { or, line 38 }
                Repeat
                    v_3 := FCursor;
                    Repeat
                        { (, line 38 }
                        If (Not (OutGrouping(g_v, 97, 252))) Then
                        Begin
                            goto lab4;
                        End;
                        { gopast, line 38 }
                        While True Do
                        Begin
                            Repeat
                                If (Not (InGrouping(g_v, 97, 252))) Then
                                Begin
                                    goto lab6;
                                End;
                                goto lab5;
                            Until True;
lab6:
                            If (FCursor >= FLimit) Then
                            Begin
                                goto lab4;
                            End;
                            Inc(FCursor);
                        End;
lab5:
                        goto lab3;
                    Until True;
lab4:
                    FCursor := v_3;
                    { (, line 38 }
                    If (Not (InGrouping(g_v, 97, 252))) Then
                    Begin
                        goto lab2;
                    End;
                    { gopast, line 38 }
                    While True Do
                    Begin
                        Repeat
                            If (Not (OutGrouping(g_v, 97, 252))) Then
                            Begin
                                goto lab8;
                            End;
                            goto lab7;
                        Until True;
lab8:
                        If (FCursor >= FLimit) Then
                        Begin
                            goto lab2;
                        End;
                        Inc(FCursor);
                    End;
lab7:
                Until True;
lab3:
                goto lab1;
            Until True;
lab2:
            FCursor := v_2;
            { (, line 40 }
            If (Not (OutGrouping(g_v, 97, 252))) Then
            Begin
                goto lab0;
            End;
            { or, line 40 }
            Repeat
                v_6 := FCursor;
                Repeat
                    { (, line 40 }
                    If (Not (OutGrouping(g_v, 97, 252))) Then
                    Begin
                        goto lab10;
                    End;
                    { gopast, line 40 }
                    While True Do
                    Begin
                        Repeat
                            If (Not (InGrouping(g_v, 97, 252))) Then
                            Begin
                                goto lab12;
                            End;
                            goto lab11;
                        Until True;
lab12:
                        If (FCursor >= FLimit) Then
                        Begin
                            goto lab10;
                        End;
                        Inc(FCursor);
                    End;
lab11:
                    goto lab9;
                Until True;
lab10:
                FCursor := v_6;
                { (, line 40 }
                If (Not (InGrouping(g_v, 97, 252))) Then
                Begin
                    goto lab0;
                End;
                { next, line 40 }
                If (FCursor >= FLimit) Then
                Begin
                    goto lab0;
                End;
                Inc(FCursor);
            Until True;
lab9:
        Until True;
lab1:
        { setmark pV, line 41 }
        I_pV := FCursor;
    Until True;
lab0:
    FCursor := v_1;
    { do, line 43 }
    v_8 := FCursor;
    Repeat
        { (, line 43 }
        { gopast, line 44 }
        While True Do
        Begin
            Repeat
                If (Not (InGrouping(g_v, 97, 252))) Then
                Begin
                    goto lab15;
                End;
                goto lab14;
            Until True;
lab15:
            If (FCursor >= FLimit) Then
            Begin
                goto lab13;
            End;
            Inc(FCursor);
        End;
lab14:
        { gopast, line 44 }
        While True Do
        Begin
            Repeat
                If (Not (OutGrouping(g_v, 97, 252))) Then
                Begin
                    goto lab17;
                End;
                goto lab16;
            Until True;
lab17:
            If (FCursor >= FLimit) Then
            Begin
                goto lab13;
            End;
            Inc(FCursor);
        End;
lab16:
        { setmark p1, line 44 }
        I_p1 := FCursor;
        { gopast, line 45 }
        While True Do
        Begin
            Repeat
                If (Not (InGrouping(g_v, 97, 252))) Then
                Begin
                    goto lab19;
                End;
                goto lab18;
            Until True;
lab19:
            If (FCursor >= FLimit) Then
            Begin
                goto lab13;
            End;
            Inc(FCursor);
        End;
lab18:
        { gopast, line 45 }
        While True Do
        Begin
            Repeat
                If (Not (OutGrouping(g_v, 97, 252))) Then
                Begin
                    goto lab21;
                End;
                goto lab20;
            Until True;
lab21:
            If (FCursor >= FLimit) Then
            Begin
                goto lab13;
            End;
            Inc(FCursor);
        End;
lab20:
        { setmark p2, line 45 }
        I_p2 := FCursor;
    Until True;
lab13:
    FCursor := v_8;
    Result := True;
End;

Function TSpanishStemmer.r_postlude : Boolean;
Var
    C : Integer;
    AmongVar : Integer;
    v_1 : Integer;
Label
    lab0,
    lab1;
Begin
    { repeat, line 49 }
lab0:
    While True Do
    Begin
        v_1 := FCursor;
        Repeat
            { (, line 49 }
            { [, line 50 }
            FBra := FCursor;
            { substring, line 50 }
            AmongVar := FindAmong(a_0, 6);
            If (AmongVar = 0) Then
            Begin
                goto lab1;
            End;
            { ], line 50 }
            FKet := FCursor;
            Case AmongVar Of
                0:
                Begin
                    goto lab1;
                End;
                1:
                Begin
                    { (, line 51 }
                    { <-, line 51 }
                    SliceFrom('a');
                End;
                2:
                Begin
                    { (, line 52 }
                    { <-, line 52 }
                    SliceFrom('e');
                End;
                3:
                Begin
                    { (, line 53 }
                    { <-, line 53 }
                    SliceFrom('i');
                End;
                4:
                Begin
                    { (, line 54 }
                    { <-, line 54 }
                    SliceFrom('o');
                End;
                5:
                Begin
                    { (, line 55 }
                    { <-, line 55 }
                    SliceFrom('u');
                End;
                6:
                Begin
                    { (, line 57 }
                    { next, line 57 }
                    If (FCursor >= FLimit) Then
                    Begin
                        goto lab1;
                    End;
                    Inc(FCursor);
                End;
            End;
            goto lab0;
        Until True;
lab1:
        FCursor := v_1;
        Break;
    End;
    Result := True;
End;

Function TSpanishStemmer.r_RV : Boolean;
Var
    C : Integer;
Begin
    If Not (I_pV <= FCursor) Then
    Begin
        Begin Result := False; Exit; End;
    End;
    Result := True;
End;

Function TSpanishStemmer.r_R1 : Boolean;
Var
    C : Integer;
Begin
    If Not (I_p1 <= FCursor) Then
    Begin
        Begin Result := False; Exit; End;
    End;
    Result := True;
End;

Function TSpanishStemmer.r_R2 : Boolean;
Var
    C : Integer;
Begin
    If Not (I_p2 <= FCursor) Then
    Begin
        Begin Result := False; Exit; End;
    End;
    Result := True;
End;

Function TSpanishStemmer.r_attached_pronoun : Boolean;
Var
    C : Integer;
    AmongVar : Integer;
Begin
    { (, line 67 }
    { [, line 68 }
    FKet := FCursor;
    { substring, line 68 }
    If (FindAmongBk(a_1, 13) = 0) Then
    Begin
        Begin Result := False; Exit; End;
    End;
    { ], line 68 }
    FBra := FCursor;
    { substring, line 72 }
    AmongVar := FindAmongBk(a_2, 11);
    If (AmongVar = 0) Then
    Begin
        Begin Result := False; Exit; End;
    End;
    { call RV, line 72 }
    If (Not r_RV) Then
    Begin
        Begin Result := False; Exit; End;
    End;
    Case AmongVar Of
        0:
        Begin
            Begin Result := False; Exit; End;
        End;
        1:
        Begin
            { (, line 73 }
            { ], line 73 }
            FBra := FCursor;
            { <-, line 73 }
            SliceFrom('iendo');
        End;
        2:
        Begin
            { (, line 74 }
            { ], line 74 }
            FBra := FCursor;
            { <-, line 74 }
            SliceFrom('ando');
        End;
        3:
        Begin
            { (, line 75 }
            { ], line 75 }
            FBra := FCursor;
            { <-, line 75 }
            SliceFrom('ar');
        End;
        4:
        Begin
            { (, line 76 }
            { ], line 76 }
            FBra := FCursor;
            { <-, line 76 }
            SliceFrom('er');
        End;
        5:
        Begin
            { (, line 77 }
            { ], line 77 }
            FBra := FCursor;
            { <-, line 77 }
            SliceFrom('ir');
        End;
        6:
        Begin
            { (, line 81 }
            { delete, line 81 }
            SliceDel;
        End;
        7:
        Begin
            { (, line 82 }
            { literal, line 82 }
            If (Not (EqSBk(1, 'u'))) Then
            Begin
                Begin Result := False; Exit; End;
            End;
            { delete, line 82 }
            SliceDel;
        End;
    End;
    Result := True;
End;

Function TSpanishStemmer.r_standard_suffix : Boolean;
Var
    C : Integer;
    AmongVar : Integer;
    v_1 : Integer;
    v_2 : Integer;
    v_3 : Integer;
    v_4 : Integer;
    v_5 : Integer;
Label
    lab0,
    lab1,
    lab2,
    lab3,
    lab4;
Begin
    { (, line 86 }
    { [, line 87 }
    FKet := FCursor;
    { substring, line 87 }
    AmongVar := FindAmongBk(a_6, 42);
    If (AmongVar = 0) Then
    Begin
        Begin Result := False; Exit; End;
    End;
    { ], line 87 }
    FBra := FCursor;
    Case AmongVar Of
        0:
        Begin
            Begin Result := False; Exit; End;
        End;
        1:
        Begin
            { (, line 98 }
            { call R2, line 99 }
            If (Not r_R2) Then
            Begin
                Begin Result := False; Exit; End;
            End;
            { delete, line 99 }
            SliceDel;
        End;
        2:
        Begin
            { (, line 103 }
            { call R2, line 104 }
            If (Not r_R2) Then
            Begin
                Begin Result := False; Exit; End;
            End;
            { delete, line 104 }
            SliceDel;
            { try, line 105 }
            v_1 := FLimit - FCursor;
            Repeat
                { (, line 105 }
                { [, line 105 }
                FKet := FCursor;
                { literal, line 105 }
                If (Not (EqSBk(2, 'ic'))) Then
                Begin
                    FCursor := FLimit - v_1;
                    goto lab0;
                End;
                { ], line 105 }
                FBra := FCursor;
                { call R2, line 105 }
                If (Not r_R2) Then
                Begin
                    FCursor := FLimit - v_1;
                    goto lab0;
                End;
                { delete, line 105 }
                SliceDel;
            Until True;
lab0:
        End;
        3:
        Begin
            { (, line 109 }
            { call R2, line 110 }
            If (Not r_R2) Then
            Begin
                Begin Result := False; Exit; End;
            End;
            { <-, line 110 }
            SliceFrom('log');
        End;
        4:
        Begin
            { (, line 113 }
            { call R2, line 114 }
            If (Not r_R2) Then
            Begin
                Begin Result := False; Exit; End;
            End;
            { <-, line 114 }
            SliceFrom('u');
        End;
        5:
        Begin
            { (, line 117 }
            { call R2, line 118 }
            If (Not r_R2) Then
            Begin
                Begin Result := False; Exit; End;
            End;
            { <-, line 118 }
            SliceFrom('ente');
        End;
        6:
        Begin
            { (, line 121 }
            { call R1, line 122 }
            If (Not r_R1) Then
            Begin
                Begin Result := False; Exit; End;
            End;
            { delete, line 122 }
            SliceDel;
            { try, line 123 }
            v_2 := FLimit - FCursor;
            Repeat
                { (, line 123 }
                { [, line 124 }
                FKet := FCursor;
                { substring, line 124 }
                AmongVar := FindAmongBk(a_3, 4);
                If (AmongVar = 0) Then
                Begin
                    FCursor := FLimit - v_2;
                    goto lab1;
                End;
                { ], line 124 }
                FBra := FCursor;
                { call R2, line 124 }
                If (Not r_R2) Then
                Begin
                    FCursor := FLimit - v_2;
                    goto lab1;
                End;
                { delete, line 124 }
                SliceDel;
                Case AmongVar Of
                    0:
                    Begin
                        FCursor := FLimit - v_2;
                        goto lab1;
                    End;
                    1:
                    Begin
                        { (, line 125 }
                        { [, line 125 }
                        FKet := FCursor;
                        { literal, line 125 }
                        If (Not (EqSBk(2, 'at'))) Then
                        Begin
                            FCursor := FLimit - v_2;
                            goto lab1;
                        End;
                        { ], line 125 }
                        FBra := FCursor;
                        { call R2, line 125 }
                        If (Not r_R2) Then
                        Begin
                            FCursor := FLimit - v_2;
                            goto lab1;
                        End;
                        { delete, line 125 }
                        SliceDel;
                    End;
                End;
            Until True;
lab1:
        End;
        7:
        Begin
            { (, line 133 }
            { call R2, line 134 }
            If (Not r_R2) Then
            Begin
                Begin Result := False; Exit; End;
            End;
            { delete, line 134 }
            SliceDel;
            { try, line 135 }
            v_3 := FLimit - FCursor;
            Repeat
                { (, line 135 }
                { [, line 136 }
                FKet := FCursor;
                { substring, line 136 }
                AmongVar := FindAmongBk(a_4, 2);
                If (AmongVar = 0) Then
                Begin
                    FCursor := FLimit - v_3;
                    goto lab2;
                End;
                { ], line 136 }
                FBra := FCursor;
                Case AmongVar Of
                    0:
                    Begin
                        FCursor := FLimit - v_3;
                        goto lab2;
                    End;
                    1:
                    Begin
                        { (, line 138 }
                        { call R2, line 138 }
                        If (Not r_R2) Then
                        Begin
                            FCursor := FLimit - v_3;
                            goto lab2;
                        End;
                        { delete, line 138 }
                        SliceDel;
                    End;
                End;
            Until True;
lab2:
        End;
        8:
        Begin
            { (, line 144 }
            { call R2, line 145 }
            If (Not r_R2) Then
            Begin
                Begin Result := False; Exit; End;
            End;
            { delete, line 145 }
            SliceDel;
            { try, line 146 }
            v_4 := FLimit - FCursor;
            Repeat
                { (, line 146 }
                { [, line 147 }
                FKet := FCursor;
                { substring, line 147 }
                AmongVar := FindAmongBk(a_5, 3);
                If (AmongVar = 0) Then
                Begin
                    FCursor := FLimit - v_4;
                    goto lab3;
                End;
                { ], line 147 }
                FBra := FCursor;
                Case AmongVar Of
                    0:
                    Begin
                        FCursor := FLimit - v_4;
                        goto lab3;
                    End;
                    1:
                    Begin
                        { (, line 150 }
                        { call R2, line 150 }
                        If (Not r_R2) Then
                        Begin
                            FCursor := FLimit - v_4;
                            goto lab3;
                        End;
                        { delete, line 150 }
                        SliceDel;
                    End;
                End;
            Until True;
lab3:
        End;
        9:
        Begin
            { (, line 156 }
            { call R2, line 157 }
            If (Not r_R2) Then
            Begin
                Begin Result := False; Exit; End;
            End;
            { delete, line 157 }
            SliceDel;
            { try, line 158 }
            v_5 := FLimit - FCursor;
            Repeat
                { (, line 158 }
                { [, line 159 }
                FKet := FCursor;
                { literal, line 159 }
                If (Not (EqSBk(2, 'at'))) Then
                Begin
                    FCursor := FLimit - v_5;
                    goto lab4;
                End;
                { ], line 159 }
                FBra := FCursor;
                { call R2, line 159 }
                If (Not r_R2) Then
                Begin
                    FCursor := FLimit - v_5;
                    goto lab4;
                End;
                { delete, line 159 }
                SliceDel;
            Until True;
lab4:
        End;
    End;
    Result := True;
End;

Function TSpanishStemmer.r_y_verb_suffix : Boolean;
Var
    C : Integer;
    AmongVar : Integer;
    v_1 : Integer;
    v_2 : Integer;
Begin
    { (, line 165 }
    { setlimit, line 166 }
    v_1 := FLimit - FCursor;
    { tomark, line 166 }
    If (FCursor < I_pV) Then
    Begin
        Begin Result := False; Exit; End;
    End;
    FCursor := I_pV;
    v_2 := FBkLimit;
    FBkLimit := FCursor;
    FCursor := FLimit - v_1;
    { (, line 166 }
    { [, line 166 }
    FKet := FCursor;
    { substring, line 166 }
    AmongVar := FindAmongBk(a_7, 12);
    If (AmongVar = 0) Then
    Begin
        FBkLimit := v_2;
        Begin Result := False; Exit; End;
    End;
    { ], line 166 }
    FBra := FCursor;
    FBkLimit := v_2;
    Case AmongVar Of
        0:
        Begin
            Begin Result := False; Exit; End;
        End;
        1:
        Begin
            { (, line 169 }
            { literal, line 169 }
            If (Not (EqSBk(1, 'u'))) Then
            Begin
                Begin Result := False; Exit; End;
            End;
            { delete, line 169 }
            SliceDel;
        End;
    End;
    Result := True;
End;

Function TSpanishStemmer.r_verb_suffix : Boolean;
Var
    C : Integer;
    AmongVar : Integer;
    v_1 : Integer;
    v_2 : Integer;
    v_3 : Integer;
    v_4 : Integer;
Label
    lab0;
Begin
    { (, line 173 }
    { setlimit, line 174 }
    v_1 := FLimit - FCursor;
    { tomark, line 174 }
    If (FCursor < I_pV) Then
    Begin
        Begin Result := False; Exit; End;
    End;
    FCursor := I_pV;
    v_2 := FBkLimit;
    FBkLimit := FCursor;
    FCursor := FLimit - v_1;
    { (, line 174 }
    { [, line 174 }
    FKet := FCursor;
    { substring, line 174 }
    AmongVar := FindAmongBk(a_8, 96);
    If (AmongVar = 0) Then
    Begin
        FBkLimit := v_2;
        Begin Result := False; Exit; End;
    End;
    { ], line 174 }
    FBra := FCursor;
    FBkLimit := v_2;
    Case AmongVar Of
        0:
        Begin
            Begin Result := False; Exit; End;
        End;
        1:
        Begin
            { (, line 177 }
            { try, line 177 }
            v_3 := FLimit - FCursor;
            Repeat
                { (, line 177 }
                { literal, line 177 }
                If (Not (EqSBk(1, 'u'))) Then
                Begin
                    FCursor := FLimit - v_3;
                    goto lab0;
                End;
                { test, line 177 }
                v_4 := FLimit - FCursor;
                { literal, line 177 }
                If (Not (EqSBk(1, 'g'))) Then
                Begin
                    FCursor := FLimit - v_3;
                    goto lab0;
                End;
                FCursor := FLimit - v_4;
            Until True;
lab0:
            { ], line 177 }
            FBra := FCursor;
            { delete, line 177 }
            SliceDel;
        End;
        2:
        Begin
            { (, line 198 }
            { delete, line 198 }
            SliceDel;
        End;
    End;
    Result := True;
End;

Function TSpanishStemmer.r_residual_suffix : Boolean;
Var
    C : Integer;
    AmongVar : Integer;
    v_1 : Integer;
    v_2 : Integer;
Label
    lab0;
Begin
    { (, line 202 }
    { [, line 203 }
    FKet := FCursor;
    { substring, line 203 }
    AmongVar := FindAmongBk(a_9, 8);
    If (AmongVar = 0) Then
    Begin
        Begin Result := False; Exit; End;
    End;
    { ], line 203 }
    FBra := FCursor;
    Case AmongVar Of
        0:
        Begin
            Begin Result := False; Exit; End;
        End;
        1:
        Begin
            { (, line 206 }
            { call RV, line 206 }
            If (Not r_RV) Then
            Begin
                Begin Result := False; Exit; End;
            End;
            { delete, line 206 }
            SliceDel;
        End;
        2:
        Begin
            { (, line 208 }
            { call RV, line 208 }
            If (Not r_RV) Then
            Begin
                Begin Result := False; Exit; End;
            End;
            { delete, line 208 }
            SliceDel;
            { try, line 208 }
            v_1 := FLimit - FCursor;
            Repeat
                { (, line 208 }
                { [, line 208 }
                FKet := FCursor;
                { literal, line 208 }
                If (Not (EqSBk(1, 'u'))) Then
                Begin
                    FCursor := FLimit - v_1;
                    goto lab0;
                End;
                { ], line 208 }
                FBra := FCursor;
                { test, line 208 }
                v_2 := FLimit - FCursor;
                { literal, line 208 }
                If (Not (EqSBk(1, 'g'))) Then
                Begin
                    FCursor := FLimit - v_1;
                    goto lab0;
                End;
                FCursor := FLimit - v_2;
                { call RV, line 208 }
                If (Not r_RV) Then
                Begin
                    FCursor := FLimit - v_1;
                    goto lab0;
                End;
                { delete, line 208 }
                SliceDel;
            Until True;
lab0:
        End;
    End;
    Result := True;
End;

Function TSpanishStemmer.stem : Boolean;
Var
    C : Integer;
    v_1 : Integer;
    v_2 : Integer;
    v_3 : Integer;
    v_4 : Integer;
    v_5 : Integer;
    v_6 : Integer;
Label
    lab0,
    lab1,
    lab2,
    lab3,
    lab4,
    lab5,
    lab6,
    lab7;
Begin
    { (, line 213 }
    { do, line 214 }
    v_1 := FCursor;
    Repeat
        { call mark_regions, line 214 }
        If (Not r_mark_regions) Then
        Begin
            goto lab0;
        End;
    Until True;
lab0:
    FCursor := v_1;
    { backwards, line 215 }
    FBkLimit := FCursor; FCursor := FLimit;
    { (, line 215 }
    { do, line 216 }
    v_2 := FLimit - FCursor;
    Repeat
        { call attached_pronoun, line 216 }
        If (Not r_attached_pronoun) Then
        Begin
            goto lab1;
        End;
    Until True;
lab1:
    FCursor := FLimit - v_2;
    { do, line 217 }
    v_3 := FLimit - FCursor;
    Repeat
        { (, line 217 }
        { or, line 217 }
        Repeat
            v_4 := FLimit - FCursor;
            Repeat
                { call standard_suffix, line 217 }
                If (Not r_standard_suffix) Then
                Begin
                    goto lab4;
                End;
                goto lab3;
            Until True;
lab4:
            FCursor := FLimit - v_4;
            Repeat
                { call y_verb_suffix, line 218 }
                If (Not r_y_verb_suffix) Then
                Begin
                    goto lab5;
                End;
                goto lab3;
            Until True;
lab5:
            FCursor := FLimit - v_4;
            { call verb_suffix, line 219 }
            If (Not r_verb_suffix) Then
            Begin
                goto lab2;
            End;
        Until True;
lab3:
    Until True;
lab2:
    FCursor := FLimit - v_3;
    { do, line 221 }
    v_5 := FLimit - FCursor;
    Repeat
        { call residual_suffix, line 221 }
        If (Not r_residual_suffix) Then
        Begin
            goto lab6;
        End;
    Until True;
lab6:
    FCursor := FLimit - v_5;
    FCursor := FBkLimit;    { do, line 223 }
    v_6 := FCursor;
    Repeat
        { call postlude, line 223 }
        If (Not r_postlude) Then
        Begin
            goto lab7;
        End;
    Until True;
lab7:
    FCursor := v_6;
    Result := True;
End;

End.
